//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <stdio.h>

#include "Zt_Visa_Epp_Test.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

long g_IsCorrectVersion = 1;
long g_BegainReadPin = 0;
int iEnablePinMode = 0; //ģʽ    0Startup1,  1:Startup2
int iStop=0;
TfmTestZt588 *fmTestZt588;

HINSTANCE g_hZt588Dll   = NULL;
int (__stdcall* g_fPinpadEnable)(char far* pCom,
                                 long lBoundRate,
                                 char far* pParity,
                                 char far* pBite,
                                 char far* pStopBite);
                                 
int (__stdcall* g_fPinpadDisable)();
int (__stdcall* g_fPinpadDownloadKey)(char far *pszKey,
                                      int iLen,
                                      char far *pszRevData);

int (__stdcall* g_fPinpadDownloadEncryptKey)(char far *pszKey,
                                             int iLen,
                                             char far *pszRevData);

int (__stdcall* g_fPinpadEnablePin)(char far *pszPinValue,
                                    int iLen);

int (__stdcall* g_fPinpadSetCustomerInfo)(char far *pszCustomerInfo,
                                          int  iLen);

int (__stdcall* g_fPinpadSetKeyboardValue)(char far *pszKeyboardValue,
                                           int  iLen);

int (__stdcall* g_fPinpadSetControlCode)(char far *pszControlCode,
                                         int  iLen);

int (__stdcall* g_fPinpadGetCustomerInfo)(char far *pszCustoInfo);

int (__stdcall* g_fPinpadGetPinValue)(char far *pszCmd,
                                      int  iLen,
                                      int  iTimeOut,
                                      char far *pszPinValue);

int (__stdcall* g_fPinpadMakeMac)(char far *pszMakeMacData,
                                  int iMacDataLen,
                                  char far *pszRevData);

int (__stdcall* g_fPinpadEncryptData)(char far *pszEncryptData,
                                      int  iDataLen,
                                      char far *pszRevData);

int (__stdcall* g_fPinpadInitAuthorization)(char far *pszAuthorizationData,
                                            int  iDataLen,
                                            char far *pszRevData);

int (__stdcall* g_fPinpadBidirectionalAuthorization)(char far *pszAuthorizationData,
                                                     int  iDataLen,
                                                     char far  *pszKeyIndex,
                                                     char far  *pszInitAuthorizaRevDate,
                                                     char far  *pszRevData);

int (__stdcall* g_fPinpadTriUnTriDes)( char far *DataInput,char far *key, char far *DataOutput,int nMode );

int (__stdcall* g_fPinpadReadOneByte)( char far *pchBuf );
int (__stdcall* g_fPinpadGetChallenge)( char far *RevData );
int (__stdcall* g_fPinPad_IC_Control)( char far *cpCommand,char far *RevData );
int (__stdcall* g_fPinPad_IC_Access)( char far *cpCommand,char far *RevData );
int (__stdcall* g_fPinPadDispInfoLcd)(char far *pszInfo, int iLen);

void GetErrStatus(int errCode, char *pchErrMsg)
{
    switch(errCode)
    {
        case 0XE0:
            strcpy(pchErrMsg, "Low battery, Need to replace the battery ");
            break;
        case 0XE1:
            strcpy(pchErrMsg, "Not IMK which can't download the master key ");
            break;
        case 0XE2:
            strcpy(pchErrMsg, "Not TMK which can't download the working key");
            break;
        case 0XE3:
            strcpy(pchErrMsg, "Wrong Key length");
            break;
        case 0XE4:
            strcpy(pchErrMsg, "Key index don't exist");
            break;
        case 0XE5:
            strcpy(pchErrMsg, "Unmatchable label or no such key");
            break;
        case 0XE6:
            strcpy(pchErrMsg, "Wrong verification odd and even of Key");
            break;
        case 0XE7:
            strcpy(pchErrMsg, "Wrong Key check");
            break;
        case 0XE8:
            strcpy(pchErrMsg, "Wrong command length");
            break;
        case 0XE9:
            strcpy(pchErrMsg, "Illegal data");
            break;
        case 0XEA:
            strcpy(pchErrMsg, "Information Code don't exist ");
            break;
        case 0XEB:
            strcpy(pchErrMsg, "Wrong Parameter type");
            break;
        case 0XEC:
            strcpy(pchErrMsg, "Certifcation failure");
            break;
        case 0XED:
            strcpy(pchErrMsg, "Certification locked");
            break;
        case 0XEE:
            strcpy(pchErrMsg, "Overtime input on EPP");
            break;
        case 0XEF:
            strcpy(pchErrMsg, "Other error");
            break;
        case 0x31:
            strcpy(pchErrMsg, "Command BCC Verify Error");
            break;
        case 0x32:
            strcpy(pchErrMsg, "Command Format Error");
            break;
        case 0x33:
            strcpy(pchErrMsg, "Command Key Error");
            break;
        case 0x34:
            strcpy(pchErrMsg, "Command Length Error");
            break;
        case 0x41:
            strcpy(pchErrMsg, "No Card");
            break;
        case 0x42:
            strcpy(pchErrMsg, "Nonstandard Card");
            break;
        case 0x43:
            strcpy(pchErrMsg, "Card Not Power Up");
            break;
        case 0x44:
            strcpy(pchErrMsg, "Card Type Nonsupport");
            break;
        case 0x45:
            strcpy(pchErrMsg, "Out Card Unsuccessfulness");
            break;
        case 0x51:
            strcpy(pchErrMsg, "Password Error Or Not Verify Password");
            break;
        case 0x52:
            strcpy(pchErrMsg, "Write Data Error");
            break;
        case 0x53:
            strcpy(pchErrMsg, "Verify Password lock up(Read Only)");
            break;
        case 0x61:
            strcpy(pchErrMsg, "Access COS Error,See SW");
            break;

        case -1:
            strcpy(pchErrMsg, "the serial port remains closed  or open the serial port improperly");
            break;
        case -2:
            strcpy(pchErrMsg, "close the serial port improperly");
            break;
        case -3:
            strcpy(pchErrMsg, "wrong parameter fed into");
            break;
        case -4:
            strcpy(pchErrMsg, "excessive time in data reading");
            break;
        default:
            strcpy(pchErrMsg, "Other error");
            break;
    }
}


void SaveKey(char *pszKeyHead, char *pszKeyIndex, char *pszKeyValue)
{
     WritePrivateProfileString(pszKeyHead, pszKeyIndex, pszKeyValue, ".\\KeyStock.txt");
}

int  MixThreeKey(char *pin1, char *pin2, char *pin3, int iIndex, char *pszRevData)
{
    int iLen1 = strlen(pin1);
    int iLen2 = strlen(pin2);
    int iLen3 = strlen(pin3);
//    char szTemp[64+1] = {0};

    switch(iIndex)
    {
        case 1:
            if (iLen1 != 8*2)
                return -1;
            if (iLen2 != 8*2)
                return -2;
            if (iLen3 != 8*2)
                return -3;
            break;
        case 2:
            if (iLen1 != 16*2)
                return -1;
            if (iLen2 != 16*2)
                return -2;
            if (iLen3 != 16*2)
                return -3;
            break;
        case 3:
            if (iLen1 != 24*2)
                return -1;
            if (iLen2 != 24*2)
                return -2;
            if (iLen3 != 24*2)
                return -3;
            break;
        default:
            break;
    }
    int nLen = iLen1/2;
    int ch1,ch2,ch3,bcccalc;
    for(int i=0;i<nLen;i++ )
    {
        bcccalc = 0;
        sscanf( pin1+i*2, "%02X", &ch1 );
        sscanf( pin2+i*2, "%02X", &ch2 );
        sscanf( pin3+i*2, "%02X", &ch3 );
        bcccalc = ch1^ch2^ch3;
        sprintf( pszRevData+i*2,"%02X", bcccalc );
    }
    return 0;
/*
    for (int i=0; i<iLen1; i++)
    {
        szTemp[i] ^= pin1[i];
        szTemp[i] ^= pin2[i];
        szTemp[i] ^= pin3[i];
    }

    memcpy(pszRevData, szTemp,iLen1);
    return 0;
*/
}


int  DataXorTwoKey(char *pin1, char *pin2, int iIndex, char *pszRevData)
{
    int iLen1 = strlen(pin1);
    int iLen2 = strlen(pin2);

    switch(iIndex)
    {
        case 1:
            if (iLen1 != 8*2)
                return -1;
            if (iLen2 != 8*2)
                return -2;
            break;
        case 2:
            if (iLen1 != 16*2)
                return -1;
            if (iLen2 != 16*2)
                return -2;
            break;
        case 3:
            if (iLen1 != 24*2)
                return -1;
            if (iLen2 != 24*2)
                return -2;
            break;
        default:
            break;
    }

    int nLen = iLen1/2;
    int ch1,ch2,bcccalc;
    for(int i=0;i<nLen;i++ )
    {
        bcccalc = 0;
        sscanf( pin1+i*2, "%02X", &ch1 );
        sscanf( pin2+i*2, "%02X", &ch2 );
        bcccalc = ch1^ch2;
        sprintf( pszRevData+i*2,"%02X", bcccalc );
    }
    return 0;
}

int  MixTwoKey(char *pin1, char *pin2,  int iIndex, char *pszRevData)
{
    int iLen1 = strlen(pin1);
    int iLen2 = strlen(pin2);
//    char  szKey1[64+1] = {0};
//    char  szKey2[64+1] = {0};
//    char  szKey3[64+1] = {0};
//    char szMixKey[128+1] = {0};

    switch(iIndex)
    {
        case 1:
            if (iLen1 != 8)
                return -1;
            if (iLen2 != 8)
                return -2;
            sprintf(pszRevData, "%s%s", pin1, pin2);
            break;
        case 2:
            if (iLen1 != 16)
                return -1;
            if (iLen2 != 16)
                return -2;

//            sprintf(szKey1, "%8s%8s", pin1, pin2);
            memcpy( pszRevData,pin1,8 );
            memcpy( pszRevData+8,pin2,8 );
            memcpy( pszRevData+8+8,pin1,8 );
            memcpy( pszRevData+8+8+8,pin2,8 );
/*
            sprintf(szKey2, "%8s%8s", pin1+8, pin2+8);
            for (int i=0; i<16; i++)
            {
                szMixKey[i] ^= szKey1[i];
                szMixKey[i] ^= szKey2[i];
            }
*/
            break;
        case 3:
            if (iLen1 != 24)
                return -1;
            if (iLen2 != 24)
                return -2;
/*
            sprintf(szKey1, "%8s%8s", pin1, pin2);
            sprintf(szKey2, "%8s%8s", pin1+8, pin2+8);
            sprintf(szKey3, "%8s%8s", pin1+16, pin2+16);
            for (int i=0; i<16; i++)
            {
                szMixKey[i] ^= szKey1[i];
                szMixKey[i] ^= szKey2[i];
                szMixKey[i] ^= szKey3[i];
            }
*/
            memcpy( pszRevData,pin1,8 );
            memcpy( pszRevData+8,pin2,8 );
            memcpy( pszRevData+8+8,pin1+8,8 );
            memcpy( pszRevData+8+8+8,pin2+8,8 );
            memcpy( pszRevData+8+8+8+8,pin1+8+8,8 );
            memcpy( pszRevData+8+8+8+8+8,pin2+8+8,8 );
            break;
        default:
            break;
    }
//    memcpy(pszRevData, szMixKey, 16);
    return 0;
}

void InitDisableButton()
{
    fmTestZt588->btOpenCom->Enabled = TRUE;
    fmTestZt588->btCloseCom->Enabled = FALSE;
    fmTestZt588->btGetVersion->Enabled = FALSE;
    fmTestZt588->btInitAuthorization->Enabled = FALSE;
    fmTestZt588->btBidirectionAuthorization->Enabled = FALSE;
    fmTestZt588->btSetCustomerInfo->Enabled = FALSE;
    fmTestZt588->btGetCustomerInfor->Enabled = FALSE;
    fmTestZt588->btSetKeyboard->Enabled = FALSE;
    fmTestZt588->btSetControlCode->Enabled = FALSE;
    fmTestZt588->btDownloadKey->Enabled = FALSE;
    fmTestZt588->btDownloadEncrypt->Enabled = FALSE;
    fmTestZt588->btEnablePin->Enabled = FALSE;
    fmTestZt588->btGetPin->Enabled = FALSE;
    fmTestZt588->btMakeMAC->Enabled = FALSE;
    fmTestZt588->btEncryptData->Enabled = FALSE;
    fmTestZt588->btDecipherData->Enabled = FALSE;
    fmTestZt588->IC_Control->Enabled = FALSE;
    fmTestZt588->IC_Access->Enabled = FALSE;
    fmTestZt588->OpenKeyBord->Enabled = FALSE;
    fmTestZt588->CloseKeyBord->Enabled = FALSE;
    fmTestZt588->Button4->Enabled = FALSE;
    fmTestZt588->Button5->Enabled = FALSE;
    fmTestZt588->Button6->Enabled = FALSE;
    fmTestZt588->TabSheet8_Display->Enabled = FALSE;
}
void InitEnableButton()
{
    fmTestZt588->btOpenCom->Enabled = FALSE;
    fmTestZt588->btGetPin->Enabled = FALSE;
    fmTestZt588->btCloseCom->Enabled = TRUE;
    fmTestZt588->btGetVersion->Enabled = TRUE;
    fmTestZt588->btInitAuthorization->Enabled = TRUE;
    fmTestZt588->btBidirectionAuthorization->Enabled = TRUE;
    fmTestZt588->btSetCustomerInfo->Enabled = TRUE;
    fmTestZt588->btGetCustomerInfor->Enabled = TRUE;
    fmTestZt588->btSetKeyboard->Enabled = TRUE;
    fmTestZt588->btSetControlCode->Enabled = TRUE;
    fmTestZt588->btDownloadKey->Enabled = TRUE;
    fmTestZt588->btDownloadEncrypt->Enabled = TRUE;
    fmTestZt588->btEnablePin->Enabled = TRUE;
    fmTestZt588->btMakeMAC->Enabled = TRUE;
    fmTestZt588->btEncryptData->Enabled = TRUE;
    fmTestZt588->btDecipherData->Enabled = TRUE;
    fmTestZt588->IC_Control->Enabled = TRUE;
    fmTestZt588->IC_Access->Enabled = TRUE;
    fmTestZt588->OpenKeyBord->Enabled = TRUE;
    fmTestZt588->CloseKeyBord->Enabled = TRUE;
    fmTestZt588->Button4->Enabled = TRUE;
    fmTestZt588->Button5->Enabled = TRUE;
    fmTestZt588->Button6->Enabled = TRUE;
    fmTestZt588->TabSheet8_Display->Enabled = TRUE;
}

//---------------------------------------------------------------------------
__fastcall TfmTestZt588::TfmTestZt588(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void Initialization()
{
    fmTestZt588->memoCustInof->Text = "";    //ÿͻϢ
    fmTestZt588->memoGetCustInfo->Text = ""; //ȡÿͻϢ
    fmTestZt588->memoMakeMacData->Text = ""; //MACõ

    //ƴ
    fmTestZt588->comboControlCode->ItemIndex = 0;

    //MAC type
    fmTestZt588->comboMacType->ItemIndex = 1;

    fmTestZt588->comboMixCode->ItemIndex = 0;    //  ϳɴ
    fmTestZt588->comboPinLength->ItemIndex = 0;  // Կ

    fmTestZt588->comboEncryptMark->ItemIndex = 0;   // Կǩ
    fmTestZt588->comboEnryptLength->ItemIndex = 0;  // Կ

    //Կ
    fmTestZt588->comboDecipherNo->ItemIndex = 0;

    //Կ
    fmTestZt588->comboEncryptNo->ItemIndex = 0;

    //ʾ
    fmTestZt588->comboHintAudio->ItemIndex = 0;

    //pin 
    fmTestZt588->comboPinType->ItemIndex = 1;

    //
    fmTestZt588->comboEncryptType->ItemIndex = 0;

    //ܷ
    fmTestZt588->memoOutput->Text = "";

    //
    fmTestZt588->memoInputData->Text = "";

    fmTestZt588->edPinLength->Text = "06";

    fmTestZt588->Memo1->Text = "";
    fmTestZt588->Memo2->Text = "";
}
void __fastcall TfmTestZt588::FormCreate(TObject *Sender)
{
    fmTestZt588->Left =35;
    fmTestZt588->Top = 130;

    FILE *fp;
//    fp = fopen(".\\KeyStock.txt","w");
//    fclose(fp);
    Initialization();
    InitDisableButton();

//    g_hZt588Dll = LoadLibrary("PinPad_588_ZT.dll");
    g_hZt588Dll = LoadLibrary("VISA_EPP_ZT_V2.dll");

    if (g_hZt588Dll == NULL)
    {
        MessageBox(NULL, "Load library PinPad_588_ZT.dll err", "Err", 1);
    }
    else
    {
        g_fPinpadEnable  =   (int (__stdcall*)(char far*,
                                               long,
                                               char far*,
                                               char far*,
                                               char far*))GetProcAddress(g_hZt588Dll,
                                                                         "PinPad_EnablePort");

        g_fPinpadDisable =   (int (__stdcall*)())GetProcAddress(g_hZt588Dll,
                                                                         "PinPad_DisablePort");

        g_fPinpadSetCustomerInfo = (int (__stdcall*)(char far*, int))GetProcAddress(g_hZt588Dll,
                                                                                               "PinPad_SetCustInfo");

        g_fPinpadGetCustomerInfo = (int (__stdcall*)(char far*))GetProcAddress(g_hZt588Dll,
                                                                                          "PinPad_GetCustInfo");

        g_fPinpadSetKeyboardValue = (int (__stdcall*)(char far*, int))GetProcAddress(g_hZt588Dll,
                                                                                               "PinPad_SetKeyboardValue");

        g_fPinpadSetControlCode = (int (__stdcall*)(char far*, int))GetProcAddress(g_hZt588Dll,
                                                                                             "PinPad_SetControlCode");

        g_fPinpadDownloadKey = (int (__stdcall*)(char far*,
                                                 int ,
                                                 char far*))GetProcAddress(g_hZt588Dll,
                                                                           "PinPad_DownloadKey");

        g_fPinpadDownloadEncryptKey  = (int (__stdcall*)(char far*,
                                                         int,
                                                         char far*))GetProcAddress(g_hZt588Dll,
                                                                                  "PinPad_DownloadEncryptKey");

        g_fPinpadInitAuthorization = (int (__stdcall*)(char far*,
                                                       int,
                                                       char far*))GetProcAddress(g_hZt588Dll,
                                                                                 "PinPad_InitAuthorization");

        g_fPinpadBidirectionalAuthorization = (int (__stdcall*)(char far*,
                                                                int,
                                                                char far*,
                                                                char far*,
                                                                char far*))GetProcAddress(g_hZt588Dll,
                                                                                          "PinPad_BidirectionalAuthorization");

        g_fPinpadEnablePin = (int (__stdcall*)(char far*, int iLen))GetProcAddress(g_hZt588Dll,
                                                                                              "PinPad_EnablePin");

        g_fPinpadGetPinValue = (int (__stdcall*) (char far*,int,int,char far *))GetProcAddress(g_hZt588Dll,
                                                                                       "PinPad_GetPinValue");

        g_fPinpadMakeMac = (int (__stdcall*)(char far *, int, char far *))GetProcAddress(g_hZt588Dll,
                                                                                                 "PinPad_MakeMac");

        g_fPinpadEncryptData = (int (__stdcall*)(char far *, int , char far*))GetProcAddress(g_hZt588Dll,
                                                                                                         "PinPad_EncryptData");

        g_fPinpadTriUnTriDes = (int (__stdcall*)(char far *, char far*, char far *,int))GetProcAddress(g_hZt588Dll,
                                                                                              "PinPad_TriUntriDes");

        g_fPinpadReadOneByte = (int (__stdcall*)(char far *))GetProcAddress(g_hZt588Dll,
                                                                          "PinPad_ReadOneByte");
        g_fPinpadGetChallenge = (int (__stdcall*)(char far *))GetProcAddress(g_hZt588Dll,
                                                                          "PinPad_GetChallenge");
        g_fPinPad_IC_Control = (int (__stdcall*)(char far *,char far *))GetProcAddress(g_hZt588Dll,
                                                                           "PinPad_IC_Control");
        g_fPinPad_IC_Access = (int (__stdcall*)(char far *,char far *))GetProcAddress(g_hZt588Dll,
                                                                           "PinPad_IC_Access");

        g_fPinPadDispInfoLcd = (int (__stdcall*)(char far*, int))GetProcAddress(g_hZt588Dll,
                                                                                             "PinPad_DispInfoLcd");
    }
    fmTestZt588->StatusBar1->Panels->Items[2]->Text = Now().TimeString() ;
    char chInit[100]={0};
    GetPrivateProfileString( "INIT_AUTH","AUTH","",chInit,100,".\\KeyStock.txt");
    edAuthorizationData->Text = chInit;
    DataSend->Text = "";
    DataRcv->Text = "";
    CardAtr->Text = "";

 //for display
        char chNo[3]={0};
        for(int i = 0x40;i <= 0x7F;i++)
        {
                sprintf( chNo,"%02X",i );
                TS8_Combox->Items->Add(chNo);
        }
        for(int i = 0x30;i <= 0x39;i++)
        {
                sprintf( chNo,"%02X",i );
                TS8_ComboBox4->Items->Add(chNo);
        }
        TS8_ComboBox4->Items->Add("41");
        TS8_ComboBox4->Items->Add("42");

}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::btOpenComClick(TObject *Sender)
{
     char szPort[10],szParity[12],szBite[12],szStopBite[5];
     long lBoundRate = 0;
     int  iRet = 0;

     iStop = 1;
     g_BegainReadPin = 0;
     fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
     memset(szPort, 0 , sizeof(szPort));
     memset(szParity, 0, sizeof(szParity));
     memset(szBite, 0, sizeof(szBite));
     memset(szStopBite, 0, sizeof(szStopBite));
     
     strcpy(szPort, comboPort->Text.c_str());
     lBoundRate = comboBoundRate->Text.ToInt();

     strcpy(szParity, comboParity->Text.c_str());

     if (!memcmp(szParity, "NO", 2))
     {
        szParity[0] = 'N';
     }
     else
     {
        szParity[0] = 'Y';
     }

     strcpy(szBite,  comboDataBit->Text.c_str());
     strcpy(szStopBite,  comboStop->Text.c_str());

     if (g_fPinpadEnable != NULL)
     {
         iRet = g_fPinpadEnable(szPort,
                                lBoundRate,
                                szParity,
                                szBite,
                                szStopBite);
     }

     if (iRet)
     {
          fmTestZt588->StatusBar1->Panels->Items[1]->Text = "fail in opening the serial port";
     }
     else
     {
          fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in opening the serial";
          InitEnableButton();
     }
}

void __fastcall TfmTestZt588::btCloseComClick(TObject *Sender)
{
      int iRet = 0;

      iStop = 1;
      g_BegainReadPin = 0;
      fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
      if (g_fPinpadDisable != NULL)
      {
          iRet   = g_fPinpadDisable();
      }
      
      if (iRet)
      {
          fmTestZt588->StatusBar1->Panels->Items[1]->Text ="failure in closing the serial";
          return;
      }

      InitDisableButton();
      fmTestZt588->StatusBar1->Panels->Items[1]->Text = "serial which has been closed";
}


void __fastcall TfmTestZt588::btGetVersionClick(TObject *Sender)
{
     char szData[256], szErrMsg[128]={0},szErr[128] = {0}, szTemp[64];
     int iRet;

     iStop = 1;
     memset(szData, 0, sizeof(szData));

     g_BegainReadPin = 0;
     InitDisableButton();
     fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
     edProductType->Text = "";
     edHardwareVersion->Text = "";
     edSoftwareVersion->Text = "";
     edDate->Text = "";
     edProductNO->Text = "";
     edRemark->Text = "";
     if (g_fPinpadGetCustomerInfo == NULL)
     {
         fmTestZt588->StatusBar1->Panels->Items[1]->Text = "invalied function";
         InitEnableButton();
         return;
     }

     iRet = g_fPinpadGetCustomerInfo(szData);

     InitEnableButton();
     if (iRet)
     {
          GetErrStatus(iRet,szErrMsg);
          if ( iRet!=0xe0 )
          {
              sprintf(szErr, "failure in user information reading,the failure reason is:%s", szErrMsg);
              fmTestZt588->StatusBar1->Panels->Items[1]->Text = szErr;
              return;
          }
          else
          {
              sprintf(szErr, "read the user information:%s", szErrMsg);
              fmTestZt588->StatusBar1->Panels->Items[1]->Text = szErr;
          }
     }

     memset(szTemp, 0, sizeof(szTemp));
     memcpy(szTemp,szData+118, 8);

     edRemark->Text = szTemp;

     memset(szTemp, 0, sizeof(szTemp));
     memcpy(szTemp,szData+8+118, 6);

     edProductType->Text = szTemp;

     memset(szTemp, 0, sizeof(szTemp));
     memcpy(szTemp,szData+14+118, 3);

     edHardwareVersion->Text = szTemp;

     if (memcmp("B1", szTemp, 2))
     {
         g_IsCorrectVersion = 0;
         if ( iRet!=0xe0 )
             fmTestZt588->StatusBar1->Panels->Items[1]->Text = "the program will only provide 'B1X' series test";
     }

     memset(szTemp, 0, sizeof(szTemp));
     memcpy(szTemp,szData+17+118, 3);

     edSoftwareVersion->Text = szTemp;

     memset(szTemp, 0, sizeof(szTemp));
     memcpy(szTemp,szData+20+118, 4);

     edDate->Text = szTemp;

     memset(szTemp, 0, sizeof(szTemp));
     memcpy(szTemp,szData+24+118, 4);

     edProductNO->Text = szTemp;

     if ( iRet!=0xe0 )
         fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in implementation";
}

void __fastcall TfmTestZt588::FormDestroy(TObject *Sender)
{
     if (g_hZt588Dll != NULL)
     {
         FreeLibrary(g_hZt588Dll);
     }
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::btSetCustomerInfoClick(TObject *Sender)
{
    char szInfo[51],chErrMsg[100]={0},szErr[128] = {0};
    int iRet = 0;

    iStop = 1;
    memset(szInfo, 0, sizeof(szInfo));

    g_BegainReadPin = 0;
    InitDisableButton();
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    strcpy(szInfo, memoCustInof->Text.c_str());

    if (strlen(szInfo) <= 0)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "no user information is forbidden";
        memoCustInof->SetFocus();
        InitEnableButton();
        return;
    }

    if (g_fPinpadSetCustomerInfo)
    {
        iRet = g_fPinpadSetCustomerInfo(szInfo,strlen(szInfo));
        InitEnableButton();
        if (!iRet)
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in setting the user information";
        }
        else
        {
            GetErrStatus(iRet,chErrMsg);
            sprintf(szErr, "set the user information,failure reason is:%s", chErrMsg);
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        }
    }
    else
    {
        InitEnableButton();
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   "failure in selecting 'DLL' function";
    }
}
//---------------------------------------------------------------------------


void __fastcall TfmTestZt588::comboControlCodeChange(TObject *Sender)
{
    int iValue;// = comboControlCode->Text.ToInt();
    int i;
    char chNo[3]={0};
    sscanf(comboControlCode->Text.c_str(),"%X",&iValue );

    switch(iValue)
    {
        case 0:
            Label52->Visible = FALSE;
            RadioGroup1->Visible = FALSE;
            labelControlCode->Caption = "control code initializatio value";
            edControlCode->Clear() ;
            edControlCode->Text = "30";
            for ( int i=0x30;i<=0x3F;i++ )
            {
                sprintf( chNo,"%02X",i );
                edControlCode->Items->Add(chNo);
            }
            break;
        case 1:
            Label52->Visible = TRUE;
            RadioGroup1->Visible = TRUE;
            labelControlCode->Caption = "short key board failure /restore";
            edControlCode->Clear() ;
            edControlCode->Text = "30";
            edControlCode->Items->Add("08");
            edControlCode->Items->Add("0D");
            edControlCode->Items->Add("1B");
            edControlCode->Items->Add("2A");
            edControlCode->Items->Add("2E");
            for ( i=0x30;i<=0x39;i++ )
            {
                sprintf( chNo,"%02X",i );
                edControlCode->Items->Add(chNo);
            }
            for ( i=0x41;i<=0x48;i++ )
            {
                sprintf( chNo,"%02X",i );
                edControlCode->Items->Add(chNo);
            }
            break;
        case 2:
            Label52->Visible = FALSE;
            RadioGroup1->Visible = FALSE;
            labelControlCode->Caption = "Overtime then input PIN(second)";
            edControlCode->Clear() ;
            edControlCode->Text = "20";
            for ( i=0x01;i<=0xFF;i++ )
            {
                sprintf( chNo,"%02X",i );
                edControlCode->Items->Add(chNo);
            }
            break;
        case 3:
            Label52->Visible = FALSE;
            RadioGroup1->Visible = FALSE;
            labelControlCode->Caption = "PIN fill code";
            edControlCode->Clear() ;
            edControlCode->Text = "20";
            for ( i=0x00;i<=0xFF;i++ )
            {
                sprintf( chNo,"%02X",i );
                edControlCode->Items->Add(chNo);
            }
            break;
        case 4:
            Label52->Visible = FALSE;
            RadioGroup1->Visible = FALSE;
            labelControlCode->Caption = "PIN minimum length";
            edControlCode->Clear() ;
            edControlCode->Text = "06";
            for ( i=0x00;i<=0x10;i++ )
            {
                sprintf( chNo,"%02d",i );
                edControlCode->Items->Add(chNo);
            }
            break;
        case 5:
            Label52->Visible = FALSE;
            RadioGroup1->Visible = FALSE;
            labelControlCode->Caption = "PIN maximum length";
            edControlCode->Clear() ;
            edControlCode->Text = "06";
            for ( i=0x00;i<=0x10;i++ )
            {
                sprintf( chNo,"%02d",i );
                edControlCode->Items->Add(chNo);
            }
            break;
        case 6:
            Label52->Visible = FALSE;
            RadioGroup1->Visible = FALSE;
            labelControlCode->Caption = "set communication parameter";
            edControlCode->Clear() ;
            edControlCode->Text = "30";
            for ( i=0x30;i<=0x37;i++ )
            {
                sprintf( chNo,"%02X",i );
                edControlCode->Items->Add(chNo);
            }
            for ( i=0x41;i<=0x48;i++ )
            {
                sprintf( chNo,"%02X",i );
                edControlCode->Items->Add(chNo);
            }
            break;
        case 7:
            Label52->Visible = FALSE;
            RadioGroup1->Visible = FALSE;
//            labelControlCode->Caption = "Beep then press key";
            labelControlCode->Caption = "Voice prompt";

            edControlCode->Clear() ;
            edControlCode->Text = "30";
            for ( i=0x30;i<=0x32;i++ )
            {
                sprintf( chNo,"%02X",i );
                edControlCode->Items->Add(chNo);
            }
            break;
        case 8:
            Label52->Visible = FALSE;
            RadioGroup1->Visible = FALSE;
//            labelControlCode->Caption = "select IC card socket value";
            labelControlCode->Caption = "buzzer timing 1% secs.";

            edControlCode->Clear() ;
            edControlCode->Text = "20";
            for ( i=0x00;i<=0xFF;i++ )
            {
                sprintf( chNo,"%02X",i );
                edControlCode->Items->Add(chNo);
            }
            break;
        case 9:
            Label52->Visible = FALSE;
            RadioGroup1->Visible = FALSE;
            labelControlCode->Caption = "protection code in information area";
            edControlCode->Clear() ;
            edControlCode->Text = "30";
            for ( i=0x30;i<=0x38;i++ )
            {
                sprintf( chNo,"%02X",i );
                edControlCode->Items->Add(chNo);
            }
            break;
        case 10:
            Label52->Visible = FALSE;
            RadioGroup1->Visible = FALSE;
            labelControlCode->Caption = "Key-press timing(secs.)";
            edControlCode->Clear() ;
            edControlCode->Text = "10";
            for ( i=0x10;i<=0x1F;i++ )
            {
                sprintf( chNo,"%02X",i );
                edControlCode->Items->Add(chNo);
            }
            break;
        case 11:
            Label52->Visible = FALSE;
            RadioGroup1->Visible = FALSE;
            labelControlCode->Caption = "Press 'CLEAR' manage";
            edControlCode->Clear() ;
            edControlCode->Text = "20";
            for ( i=0x20;i<=0x22;i++ )
            {
                sprintf( chNo,"%02X",i );
                edControlCode->Items->Add(chNo);
            }
            break;
        default:
            break;
      }
}

//---------------------------------------------------------------------------


void __fastcall TfmTestZt588::comboPinLengthChange(TObject *Sender)
{
    int iIndex = comboPinLength->ItemIndex;
    if ( comboMixCode->ItemIndex ==3 )
    {
         edPin1->MaxLength = 8*2;
         edPin2->MaxLength = 8*2;
         edPin3->MaxLength = 8*2;
         return;
    }

    if ( comboMixCode->ItemIndex ==2 )
    {
        switch(iIndex)
        {
            case 0:
                edPin1->MaxLength = 8;
                edPin2->MaxLength = 8;
                edPin3->MaxLength = 8;
                return;
            case 1:
                edPin1->MaxLength = 16;
                edPin2->MaxLength = 16;
                edPin3->MaxLength = 16;
                return;
            case 2:
                edPin1->MaxLength = 24;
                edPin2->MaxLength = 24;
                edPin3->MaxLength = 24;
                return;
            default:
                edPin1->MaxLength = 16;
                edPin2->MaxLength = 16;
                edPin3->MaxLength = 16;
                return;
       }
    }

    switch(iIndex)
    {
        case 0:
             edPin1->MaxLength = 8*2;
             edPin2->MaxLength = 8*2;
             edPin3->MaxLength = 8*2;
             break;
        case 1:
             edPin1->MaxLength = 16*2;
             edPin2->MaxLength = 16*2;
             edPin3->MaxLength = 16*2;
             break;
        case 2:
             edPin1->MaxLength = 24*2;
             edPin2->MaxLength = 24*2;
             edPin3->MaxLength = 24*2;
             break;
        default:
             edPin1->MaxLength = 24*2;
             edPin2->MaxLength = 24*2;
             edPin3->MaxLength = 24*2;
             break;
    }
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::comboMixCodeChange(TObject *Sender)
{
    int iIndex = comboMixCode->ItemIndex;
    comboPinLength->Clear() ;
    comboPinLength->Items->Add("8");
    comboPinLength->Items->Add("16");
    comboPinLength->Items->Add("24");
    comboPinLength->ItemIndex = 0;

    switch(iIndex)
    {
        case 0:             //30     ʾǰ40hEPPԿֱΪԿ
            btDownloadKey->Enabled = TRUE;
            Button3->Enabled = FALSE;
            Label23->Caption = "combined code:";
            edPin1->Enabled = TRUE;
            edPin2->Enabled = FALSE;
            edPin3->Enabled = FALSE;
            edPin2->Text = "";
            edPin3->Text = "";
            break;
        case 1:              //31       ʾǰ41h42h43hEPP3ΪԿ
            btDownloadKey->Enabled = TRUE;
            Button3->Enabled = FALSE;
            Label23->Caption = "combined code:";
            edPin1->Enabled = TRUE;
            edPin2->Enabled = TRUE;
            edPin3->Enabled = TRUE;
            break;
        case 2:              //32       ʾǰ41h42hEPP2ΪԿ
            btDownloadKey->Enabled = TRUE;
            Button3->Enabled = FALSE;
            Label23->Caption = "combined code:";
            edPin1->Enabled = TRUE;
            edPin2->Enabled = TRUE;
            edPin3->Enabled = FALSE;
            edPin3->Text = "";
            break;
        case 3:              //33      EPP3ΪԿ
            btDownloadKey->Enabled = TRUE;
            Button3->Enabled = FALSE;
            comboPinLength->Clear() ;
            comboPinLength->Items->Add("24");
            comboPinLength->ItemIndex = 0;

            Label23->Caption = "combined code:";
            edPin1->Enabled = TRUE;
            edPin2->Enabled = TRUE;
            edPin3->Enabled = TRUE;
            edPin1->MaxLength = 8*2;
            edPin2->MaxLength = 8*2;
            edPin3->MaxLength = 8*2;
            return;
//            break;
        case 4:              //34      EPP2ΪԿ
            btDownloadKey->Enabled = TRUE;
            Button3->Enabled = FALSE;
            Label23->Caption = "combined code:";
            edPin1->Enabled = TRUE;
            edPin2->Enabled = TRUE;
            edPin3->Enabled = FALSE;
            edPin3->Text = "";
            break;
        case 5:              //40 ҪģEPPݡֻIMKݴȴϳɡ
            btDownloadKey->Enabled = FALSE;
            Button3->Enabled = TRUE;
            Label23->Caption = "Manually Input:";
            edPin1->Enabled = TRUE;
            edPin2->Enabled = FALSE;
            edPin3->Enabled = FALSE;
            edPin1->Text = "";
            edPin2->Text = "";
            edPin3->Text = "";
            break;
        case 6:              //41 ҪģEPPݡֻIMKݴȴϳɡ
            btDownloadKey->Enabled = FALSE;
            Button3->Enabled = TRUE;
            comboPinLength->Items->Add("32");
            comboPinLength->Items->Add("40");
            comboPinLength->Items->Add("48");
            Label23->Caption = "Manually Input:";
            edPin1->Enabled = TRUE;
            edPin2->Enabled = FALSE;
            edPin3->Enabled = FALSE;
            edPin1->Text = "";
            edPin2->Text = "";
            edPin3->Text = "";
            break;
        case 7:              //42 ҪģEPPݡֻIMKݴȴϳɡ
            btDownloadKey->Enabled = FALSE;
            Button3->Enabled = TRUE;
            comboPinLength->Items->Add("32");
            comboPinLength->Items->Add("40");
            comboPinLength->Items->Add("48");
            Label23->Caption = "Manually Input:";
            edPin1->Enabled = FALSE;
            edPin2->Enabled = TRUE;
            edPin3->Enabled = FALSE;
            edPin1->Text = "";
            edPin2->Text = "";
            edPin3->Text = "";
            break;
        case 8:              //43 ҪģEPPݡֻIMKݴȴϳɡ
            btDownloadKey->Enabled = FALSE;
            Button3->Enabled = TRUE;
            comboPinLength->Items->Add("32");
            comboPinLength->Items->Add("40");
            comboPinLength->Items->Add("48");
            Label23->Caption = "Manually Input:";
            edPin1->Enabled = FALSE;
            edPin2->Enabled = FALSE;
            edPin3->Enabled = TRUE;
            edPin1->Text = "";
            edPin2->Text = "";
            edPin3->Text = "";
            break;
        default:
            edPin1->Enabled = FALSE;
            edPin2->Enabled = FALSE;
            edPin3->Enabled = FALSE;
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "this combination code has been cancelled in  use";
            break;
    }
    comboPinLengthChange(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TfmTestZt588::comboEnryptLengthChange(TObject *Sender)
{
    int iIndex = comboEnryptLength->ItemIndex;

    switch(iIndex)
    {
        case 0:
            edInputKeyToEncrypt->MaxLength = 8*2;
            edEncrypKey->MaxLength = 8*2;
            break;
        case 1:
            edInputKeyToEncrypt->MaxLength = 16*2;
            edEncrypKey->MaxLength = 16*2;
            break;
        case 2:
            edInputKeyToEncrypt->MaxLength = 24*2;
            edEncrypKey->MaxLength = 24*2;
            break;
        default:
            edInputKeyToEncrypt->MaxLength = 16*2;
            edEncrypKey->MaxLength = 16*2;
            break;
    }
}
//---------------------------------------------------------------------------


void __fastcall TfmTestZt588::btDownloadKeyClick(TObject *Sender)
{
    char szKeyValue[128] = {0},chKeyLabel[10]={0}, szDownloadKey[256] = {0};
    char szPin1[128] = {0},szPin2[128] = {0},szPin3[128] = {0},szKeyNo[3]  = {0};
    char szRevData[128] = {0},chErrMsg[100]={0},szErr[128]={0};

    int iRet = 0, iGetKey = 0;
    //ϳɴ
    int iMixNo;// =  comboMixCode->ItemIndex;
    sscanf( comboMixCode->Text.c_str(),"%02X",&iMixNo );
    //Կȴ
    int iKeyLength = comboPinLength->ItemIndex;

    iStop = 1;
    edDownLoadKeyRetValue->Text = "";
    g_BegainReadPin = 0;
    InitDisableButton();
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    //key  
    memcpy(szKeyNo, comboKeyNo->Text.c_str(),2);
    if (strlen(szKeyNo) <= 0)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "vacant key no. is forbidden(value range : 00 - 1F)";
        comboKeyNo->SetFocus();
        InitEnableButton();
        return;
    }
    else
    {
        if ( (szKeyNo[0]<'0') || (szKeyNo[0]>'1') || (szKeyNo[1]<'0') || ( (szKeyNo[1]>'9') && (szKeyNo[1]<'A') ) || (szKeyNo[1]>'F') )
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "invalid key no.(value range:00-1F)";
            comboKeyNo->SetFocus();
            InitEnableButton();
            return;
        }
    }

    strcpy(szPin1, edPin1->Text.c_str());
    if ((strlen(szPin1) <= 0)||(memcmp(szPin1,"********",8)==0)||(iMixNo>=0x40))
    {
        if ( iMixNo==0x40 )
        {
///////////////zph 2005/12/08/////////////////////////
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "at present ,don't support this combination code please other combination code";
            InitEnableButton();
            return;
//////////////////////////////////////////////////////
/*
            if ( comboPinLength->Text.ToInt()==8 )
                sprintf(szDownloadKey, "%s%c2", szKeyNo, iMixNo);
            else if ( comboPinLength->Text.ToInt()==16 )
                sprintf(szDownloadKey, "%s%c4", szKeyNo, iMixNo);
            else
                sprintf(szDownloadKey, "%s%c6", szKeyNo, iMixNo);
*/
        }
        else
        {
///////////////zph 2005/12/08/////////////////////////
            if ( iMixNo==0x30 )
            {
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "at present ,don't support this combination code please other combination code";
                InitEnableButton();
                return;
            }
//////////////////////////////////////////////////////
            if ( iMixNo==0x33 )
                sprintf(szDownloadKey, "%s%c%d", szKeyNo, iMixNo, iKeyLength+1+2);
            else
                sprintf(szDownloadKey, "%s%c%d", szKeyNo, iMixNo, iKeyLength+1);
        }
        strcpy(szKeyValue, "****************");
        strcpy(szPin1, "****************" );
        strcpy(szPin2, "****************" );
        strcpy(szPin3, "****************" );
    }
    else
    {
        switch(iMixNo-0x30)
        {
            case 0:
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "at present ,don't support this combination code please other combination code";
                InitEnableButton();
                return;
/*
                sprintf(szDownloadKey, "%s%c%d%s", szKeyNo, iMixNo, iKeyLength+1, szPin1);
                strcpy(szKeyValue, szPin1);
                break;
*/
            case 1:
                strcpy(szPin2, edPin2->Text.c_str());
                if (strlen(szPin2) <= 0)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second  part clear text key can't be vacant";
                    edPin2->SetFocus();
                    InitEnableButton();
                    return;
                }
                strcpy(szPin3, edPin3->Text.c_str());
                if (strlen(szPin3) <= 0)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the third  part clear text key can't be vacant";
                    edPin3->SetFocus();
                    InitEnableButton();
                    return;
                }

                sprintf(szDownloadKey, "%s%c%d%s%s%s", szKeyNo, iMixNo, iKeyLength+1, szPin1, szPin2, szPin3);
                iGetKey =   MixThreeKey(szPin1, szPin2, szPin3, iKeyLength+1, szKeyValue);

                if ( iGetKey == -1)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the first part clear test key length is not long enough";
                    edPin1->SetFocus();
                    InitEnableButton();
                    return;
                }
                if ( iGetKey == -2)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second  part clear test key length is not long enough";
                    edPin2->SetFocus();
                    InitEnableButton();
                    return;
                }
                if ( iGetKey == -3)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the third  part clear test key length is not long enough";
                    edPin2->SetFocus();
                    InitEnableButton();
                    return;
                }
                break;
            case 2:
                strcpy(szPin2, edPin2->Text.c_str());
                if (strlen(szPin2) <= 0)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second  part clear text key can't be vacant";
                    InitEnableButton();
                    return;
                }
                sprintf(szDownloadKey, "%s%c%d%s%s", szKeyNo, iMixNo, iKeyLength+1, szPin1, szPin2);

                iGetKey =  MixTwoKey(szPin1, szPin2,  iKeyLength+1, szKeyValue);
                if ( iGetKey == -1)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the first part clear test key length is not long enough";
                    edPin1->SetFocus();
                    InitEnableButton();
                    return;
                }
                if ( iGetKey == -2)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second  part clear test key length is not long enough";
                    edPin2->SetFocus();
                    InitEnableButton();
                    return;
                }
                break;
            case 3:
                if (strlen(szPin1) != 16)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the first part clear test key length is 8 bytes(16 character)";
                    InitEnableButton();
                    return;
                }
                strcpy(szPin2, edPin2->Text.c_str());
                if (strlen(szPin2) != 16)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second part clear test key length is 8 bytes16 character";
                    InitEnableButton();
                    return;
                }
                strcpy(szPin3, edPin3->Text.c_str());
                if (strlen(szPin3) != 16)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the third part clear test key length is 8 bytes16 character";
                    InitEnableButton();
                    return;
                }
                sprintf(szDownloadKey, "%s%c%d%s%s%s", szKeyNo, iMixNo, iKeyLength+1+2, szPin1, szPin2, szPin3);
                sprintf( szKeyValue,"%s%s%s", szPin1, szPin2, szPin3 );
                break;
            case 4:
                strcpy(szPin2, edPin2->Text.c_str());
                if (strlen(szPin2) <= 0)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second  part clear test key length is not long enough";
                    edPin2->SetFocus();
                    InitEnableButton();
                    return;
                }
                sprintf(szDownloadKey, "%s%c%d%s%s", szKeyNo, iMixNo, iKeyLength+1, szPin1, szPin2 );
                iGetKey = DataXorTwoKey(szPin1, szPin2, iKeyLength+1, szKeyValue);

                if ( iGetKey == -1)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the first part clear test key length error";
                    edPin1->SetFocus();
                    InitEnableButton();
                    return;
                }
                if ( iGetKey == -2)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second part clear test key length error";
                    edPin2->SetFocus();
                    InitEnableButton();
                    return;
                }
                break;
            default:
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "at present ,don't support this combination code please other combination code";
                InitEnableButton();
                return;
        }
    }

    if (g_fPinpadDownloadKey)
    {
        InitEnableButton();
        iRet = g_fPinpadDownloadKey(szDownloadKey,
                                    strlen(szDownloadKey),
                                    szRevData);
        edPin1->Text = szPin1;
        edPin2->Text = szPin2;
        edPin3->Text = szPin3;

        if (!iRet)
        {
            if ( iMixNo>=0x40 )
            {
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "Please input the clear text key from EPP";
                MSG Message;
                int i=0;
                char cpDisp[256]={0},cpBuf[3]={0};
                btCloseCom->Enabled = FALSE;
                while(1)
                {
                    if( ::PeekMessage(&Message,NULL,0,0,PM_REMOVE) )
                    {
	                ::TranslateMessage(&Message);
	                ::DispatchMessage(&Message);
                    }
                    if ( iStop == 1 )
                        break;
                    memset( cpBuf,'\0',sizeof(cpBuf) );
                    iRet = g_fPinpadReadOneByte( cpBuf );
                    if ( iRet>0 )
                    {
                        if (( (int)cpBuf[0]==0x1B )||( (int)cpBuf[0]==(int)0x80))
                        {
                            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "Canceled input or timeout in the clear text key";
                            InitEnableButton();
                            btCloseCom->Enabled = TRUE;
                            break;
                        }
                        if ( cpBuf[0]==0x08 )
                        {
                            if ( i>=1 )
                            {
                                i--;
                                cpDisp[i]='\0';
                            }
                            if ((iMixNo==0x40 )||(iMixNo==0x41 ))
                                edPin1->Text = cpDisp;
                            else if ( iMixNo==0x42 )
                                edPin2->Text = cpDisp;
                            else
                                edPin3->Text = cpDisp;
                            continue;
                        }
                        if ( cpBuf[0]==0x0d )
                        {
                            btCloseCom->Enabled = TRUE;
                            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in the clear text key";
                            if ((iMixNo==0x40 )||(iMixNo==0x41 ))
                            {
                                sprintf( chKeyLabel,"%s_1",szKeyNo );
                                SaveKey("KEY_MINWEN", chKeyLabel, cpDisp);
                            }
                            else if ( iMixNo==0x42 )
                            {
                                sprintf( chKeyLabel,"%s_2",szKeyNo );
                                SaveKey("KEY_MINWEN", chKeyLabel, cpDisp);
                            }
                            else
                            {
                                sprintf( chKeyLabel,"%s_3",szKeyNo );
                                SaveKey("KEY_MINWEN", chKeyLabel, cpDisp);
                            }
                            char cpKeyVal[128]={0};
                            sprintf( cpKeyVal,"%s_V",szKeyNo );
                            SaveKey("KEY_MINWEN",cpKeyVal,"****************");
                            InitEnableButton();
                            break;
                        }
                        cpDisp[i]=cpBuf[0];
                        i++;
                        if ((iMixNo==0x40 )||(iMixNo==0x41 ))
                            edPin1->Text = cpDisp;
                        else if ( iMixNo==0x42 )
                            edPin2->Text = cpDisp;
                        else
                            edPin3->Text = cpDisp;
                    }
                }
            }
            else
            {
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in downloading the clear text key";
                edDownLoadKeyRetValue->Text = szRevData;

                sprintf( chKeyLabel,"%s_1",szKeyNo );
                SaveKey("KEY_MINWEN", chKeyLabel, szPin1);
                sprintf( chKeyLabel,"%s_2",szKeyNo );
                SaveKey("KEY_MINWEN", chKeyLabel, szPin2);
                sprintf( chKeyLabel,"%s_3",szKeyNo );
                SaveKey("KEY_MINWEN", chKeyLabel, szPin3);
                char cpKeyVal[128]={0};
                sprintf( cpKeyVal,"%s_V",szKeyNo );
                SaveKey("KEY_MINWEN",cpKeyVal,szKeyValue);
                InitEnableButton();
            }
        }
        else
        {
            GetErrStatus(iRet,chErrMsg);
            edDownLoadKeyRetValue->Text = "";
            sprintf(szErr, "failure in downloading clear text key,the failure reason is:%s", chErrMsg);
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        }
     }
     else
     {
        InitEnableButton();
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "failure in selecting function PinPad_DownloadKey()";
     }
}
//---------------------------------------------------------------------------

void DataXorData(char *pchBuf1,char *pchBuf2,char *pchOut)
{
    int  i, bcccalc, ch1,ch2,nLen;

    nLen = strlen(pchBuf1)/2;
    for(i=0;i<nLen;i++ )
    {
        bcccalc = 0;
        sscanf( pchBuf1+i*2, "%02X", &ch1 );
        if ( strlen(pchBuf2)==0 )
            ch2=0;
        else
            sscanf( pchBuf2+i*2, "%02X", &ch2 );
        bcccalc = ch1^ch2;
        sprintf( pchOut+i*2,"%02X", bcccalc );
    }
}
void ChangeByteKey( int chIn,int *chOut )
{
    int nKey=0;
    int ch;
    int ch1;

    ch = chIn;
    for ( int i=0;i<8;i++ )
    {
        ch1 = (ch<<i)&0x80;
        if ( (ch1&0xff)==0x80 )
        {
            if ( nKey==1 )
                nKey = 0;
            else nKey = 1;
        }
    }
    if ( nKey==0 )
        *chOut = chIn^0x01;
    else
        *chOut = chIn;
}

void ChangeWorkingKey( char *pchIn,char *pchOut )
{
    int chKeyIn,chKeyOut;
    int i,nLen;

    nLen = strlen(pchIn)/2;
    for ( i=0;i<nLen;i++ )
    {
         sscanf( pchIn+i*2,"%02X",&chKeyIn );
         ChangeByteKey( chKeyIn,&chKeyOut );
         sprintf( pchOut+i*2,"%02X",chKeyOut&0xFF );
    }
    pchOut[i*2] = '\0';
}

void __fastcall TfmTestZt588::btDownloadEncryptClick(TObject *Sender)
{
    char szEncryptKey[128] = {0},chVer[9]={0},szDownloadKey[256] = {0};
    char chMKey[49]={0},chKeyNo[10]={0},chTemp[49]={0};  //chMKey1[49]={0},chMKey2[49]={0},chMKey3[49]={0},
    char szRevData[128]={0},chKeyTmp[49]={0},chErrMsg[100]={0},szErr[128]={0};
       //Կ  comboDecipherNo
    char szDecipherNo[20] = {0};
      //Կ comboEncryptNo
    char szSaveKeyNo[20] = {0};
    unsigned char chDecipher[128]={0};
    int iVerifyValue = 0, iRet = 0;

      //Կȴ
    int iKeyLength = comboEnryptLength->ItemIndex;
      //Կǩ
    int iEncryptKeyMark;
    
    if ( comboEncryptMark->ItemIndex>=2 )
        iEncryptKeyMark = comboEncryptMark->ItemIndex+1;
    else iEncryptKeyMark = comboEncryptMark->ItemIndex;

    iStop = 1;
    g_BegainReadPin = 0;
    Edit15->Text = "";
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    InitDisableButton();
    Edit15->Text = "";

    strcpy(szDecipherNo, comboDecipherNo->Text.c_str());
    strcpy(szSaveKeyNo, comboEncryptNo->Text.c_str());

    if (strlen(szDecipherNo) <= 0)        //Կ
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "decryption key no.won't be vacantvalue range:00-3F";
        comboDecipherNo->SetFocus();
        InitEnableButton();
        return;
    }
    else
    {
        sscanf(szDecipherNo, "%02X", &iVerifyValue);
        if ((iVerifyValue < 0) || (iVerifyValue > 63))
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "invalid decryption key no. value range:00-3F";
            comboDecipherNo->SetFocus();
            InitEnableButton();
            return;
        }
    }

    if (strlen(szSaveKeyNo) <= 0)       //Կ
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "save key no.won't be vacant value range:00-7F";
        comboDecipherNo->SetFocus();
        InitEnableButton();
        return;
    }
    else
    {
        sscanf(szSaveKeyNo, "%02X", &iVerifyValue);
        if ((iVerifyValue < 0) || (iVerifyValue > 127))
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "invalid decryption key no value range:00-7F";
            comboEncryptNo->SetFocus();
            InitEnableButton();
            return;
        }
    }
    if ( memcmp(comboEncryptMark->Text.c_str(),"NOK",3)!=0 )
    {
        sprintf( chKeyNo,"%s_V",szDecipherNo );
        GetPrivateProfileString( "KEY_MINWEN",chKeyNo,"",chMKey,100,".\\KeyStock.txt");
        if ( CheckBox1->Checked == TRUE )
        {
            unsigned char chWorkKey[49]={0};
            strcpy( chWorkKey,edInputKeyToEncrypt->Text.c_str() );
            ChangeWorkingKey( chWorkKey,chDecipher );
            edInputKeyToEncrypt->Text = (char *)chDecipher;
        }
        else
            strcpy( chDecipher,edInputKeyToEncrypt->Text.c_str() );
/////////////////////////////////////////

        if ( strlen(chDecipher)<=0 )
        {
            strcpy( szEncryptKey,edEncrypKey->Text.c_str() );
            if ( IsVerify->Checked == TRUE )
            {
                strcpy( chVer,Edit15->Text.c_str() );
                if( strlen(chVer)!=8 )
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "Verify code is must input(8 bytes)";
                    edEncrypKey->SetFocus();
                    InitEnableButton();
                    return;
                }
            }
            strcpy( chDecipher,"****************" );
        }
        else
        {
            if (( strlen(chMKey)<=0 )||(memcmp(chMKey,"********",8)==0))
            {
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "No input cleartext Key,must be input ciphertext key";
                edEncrypKey->SetFocus();
                InitEnableButton();
                return;
            }
            g_fPinpadTriUnTriDes( chDecipher,chMKey,szEncryptKey,0 );
            edEncrypKey->Text = szEncryptKey;
            if ( IsVerify->Checked == TRUE )
            {
                g_fPinpadTriUnTriDes( "0000000000000000",chDecipher,chTemp,0 );
                memcpy( chVer,chTemp,8 );
            }
        }
        if (strlen(szEncryptKey) <= 0)
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "key won't be vacant";
            edEncrypKey->SetFocus();
            InitEnableButton();
            return;
        }

        switch(iKeyLength)
        {
            case 0:
                if (strlen(szEncryptKey) != 8*2)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "key length is not enough";
                    edEncrypKey->SetFocus();
                    InitEnableButton();
                    return;
                }
                break;
            case 1:
                if (strlen(szEncryptKey) != 16*2)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "key length is not enough";
                    edEncrypKey->SetFocus();
                    InitEnableButton();
                    return;
                }
                break;
            case 2:
                if (strlen(szEncryptKey) != 24*2)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "key length is not enough";
                    edEncrypKey->SetFocus();
                    InitEnableButton();
                    return;
                }
                break;
            default:
                StatusBar1->Panels->Items[1]->Text = "wrong key length";
                InitEnableButton();
                return;
        }

    //ԿţԿţԿǩţԿȣԿЧֵ
        sprintf(szDownloadKey, "%s%s%d%d%s%s",
                           szDecipherNo,
                           szSaveKeyNo,
                           iEncryptKeyMark+2,
                           iKeyLength+1,
                           szEncryptKey,
                           chVer);
    }
    else
    {
        sprintf(szDownloadKey, "%s%s%c%d0000000000000000",
                           szDecipherNo,
                           szSaveKeyNo,
                           0x30,
                           0x01);
    }

    if (g_fPinpadDownloadEncryptKey)
    {
        iRet = g_fPinpadDownloadEncryptKey(szDownloadKey,
                                           strlen(szDownloadKey),
                                           szRevData);
        InitEnableButton();
        if (!iRet)
        {
            if ( memcmp(comboEncryptMark->Text.c_str(),"NOK",3)!=0 )
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in downloading the encryption text key";
            else
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in clear the encryption text key";

            Edit15->Text = szRevData;

            //save the key
            SaveKey("KEY_ENCRYPT", szSaveKeyNo, chDecipher);

            if ( memcmp(szSaveKeyNo,szDecipherNo,2)==0 )
            {
                sprintf( chKeyNo,"%s_1",szDecipherNo );
                GetPrivateProfileString( "KEY_MINWEN",chKeyNo,"",chKeyTmp,49,".\\KeyStock.txt");
                if ( strlen(chKeyTmp)>0 )
                {
                    SaveKey("KEY_MINWEN", chKeyNo, "");
                    sprintf( chKeyNo,"%s_2",szDecipherNo );
                    SaveKey("KEY_MINWEN", chKeyNo, "");
                    sprintf( chKeyNo,"%s_3",szDecipherNo );
                    SaveKey("KEY_MINWEN", chKeyNo, "");
                }
            }
            char chTmp[20]={0};
            strcpy( chTmp,comboEncryptMark->Text.c_str() );
            int nNum;
            sscanf(szSaveKeyNo,"%02X",&nNum);
            if ( nNum<=0x1f )
            {
                if ( strcmp(chTmp,"TMK")==0 )
                {
                    sprintf( chKeyNo,"%s_1",szSaveKeyNo );
                    SaveKey("KEY_MINWEN", chKeyNo, chDecipher);
                    sprintf( chKeyNo,"%s_2",szSaveKeyNo );
                    SaveKey("KEY_MINWEN", chKeyNo, "");
                    sprintf( chKeyNo,"%s_3",szSaveKeyNo );
                    SaveKey("KEY_MINWEN", chKeyNo, "");
                    sprintf( chKeyNo,"%s_V",szSaveKeyNo );
                    SaveKey("KEY_MINWEN", chKeyNo, chDecipher);
                }
            }
        }
        else
        {
            GetErrStatus(iRet,chErrMsg);
            Edit15->Text = "";
            sprintf(szErr, "failure in downloading encryption text key,thefailure reason is:%s", chErrMsg);
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        }
    }
    else
    {
        InitEnableButton();
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   "failure in selecting function PinPad_DownloadEncryptKey()";
    }
}
//---------------------------------------------------------------------------


void __fastcall TfmTestZt588::btEnablePinClick(TObject *Sender)
{
    char szKeyNo[10]={0},szPinType=0,szHintCode[50]={0},szPinLength[5]={0};
    char szSendAccount[32]={0},szAccount[32]={0},szEnablePin[256]={0},chErrMsg[100]={0},szErr[128]={0};
    int iVerifyValue=0,iAccountLen,iRet = 0;
    int  iPinType = comboPinType->ItemIndex;

    iStop = 0;
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    InitDisableButton();
    PinPadKey->Text = "";
    edPinSerialNo->Text = "";
    edPinRevLength->Text = "";
    edPinRevEncrypt->Text = "";
    PinMingWen->Text = "";
    strcpy(szKeyNo, comboPinKeyNo->Text.c_str());

    sscanf(szKeyNo, "%02X", &iVerifyValue);

    if ((iVerifyValue < 48) || (iVerifyValue > 127))
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "invalid PIN key no. value range:30-7F";
        comboPinKeyNo->SetFocus();
        InitEnableButton();
        return;
    }

    switch(iPinType)
    {
        case 0:          //ASCII
            szPinType = 0x40;
            break;
        case 1:          //ISO9564_0
            szPinType = 0x20;
            break;
        case 2:          //ISO9564_1
            szPinType = 0x21;
            break;
        case 3:          //ISO9564_3
            szPinType = 0x23;
            break;
        case 4:          //IBM3624
            szPinType = 0x30;
            break;
        default:
            break;
    }

    strcpy(szHintCode, comboHintAudio->Text.c_str());
    strcpy(szPinLength, edPinLength->Text.c_str());
    strcpy(szAccount, edAccount->Text.c_str());

    iAccountLen = strlen(szAccount);
    memcpy(szSendAccount, szAccount, iAccountLen);

    if (( iPinType==1 )||( iPinType==3 ))       //ISO9564_0     ISO9564_3
    {
        if ((iAccountLen<4)||(iAccountLen>20))
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "account length range(04-20)";
            InitEnableButton();
            return;
        }
        sprintf(szEnablePin,"%s%c%s%s%s",
                             szKeyNo,
                             szPinType,
                             szHintCode,
                             szPinLength,
                             szSendAccount );
    }
    else if ( iPinType==2 )         //ISO9564_1
    {
        if ((iAccountLen!=10))
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "transcode no.length must be 10";
            InitEnableButton();
            return;
        }
        sprintf(szEnablePin,"%s%c%s%s%s",
                             szKeyNo,
                             szPinType,
                             szHintCode,
                             szPinLength,
                             szSendAccount );
    }
    else           //ASCII     IBM3624
    {
         //Կ, pinʽ, ʾ, pin , 
        sprintf(szEnablePin,"%s%c%s%s",
                            szKeyNo,
                            szPinType,
                            szHintCode,
                            szPinLength);
    }

    if (g_fPinpadEnablePin)
    {
        iRet = g_fPinpadEnablePin(szEnablePin,
                                  strlen(szEnablePin));

        InitEnableButton();
        if (!iRet)
        {
            iEnablePinMode = 0;
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in starting PIN ,please input your password in the keyboard";
            fmTestZt588->btGetPin->Enabled = FALSE;
            g_BegainReadPin = 1;
            MSG Message;
            char chDisp[100]={0},chBuf[10];
            int i=0;
            btCloseCom->Enabled = FALSE;
            while(1)
            {
		if( ::PeekMessage(&Message,NULL,0,0,PM_REMOVE) ) {
			::TranslateMessage(&Message);
			::DispatchMessage(&Message);
		} //˴ǣٵʱ滹ʾ
                if ( g_BegainReadPin == 0 )
                {
                    btCloseCom->Enabled = TRUE;
                    return;
                }

                if ( iStop == 1 )
                    break;
                memset( chBuf,'\0',sizeof(chBuf) );
                iRet = g_fPinpadReadOneByte( chBuf );
                if ( iRet>0 )
                {
                    if ( chBuf[0]==0x08 )
                    {
                        i--;
                        chDisp[i]='\0';
                        PinPadKey->Text = chDisp;
                        continue;
                    }
                    if ( chBuf[0]==0x1B )
                    {
                        memset( chDisp,'\0',sizeof(chDisp));
                        StatusBar1->Panels->Items[1]->Text = "user has cancelled  the password input";
                        btCloseCom->Enabled = TRUE;
                        return;
                    }
                    if ( chBuf[0]==0x0d )
                    {
                        StatusBar1->Panels->Items[1]->Text = "user finish inputting the password ,and then password encryption text can be selected";
                        btGetPin->Enabled = TRUE;
                        btCloseCom->Enabled = TRUE;
                        return;
                    }
                    if ( chBuf[0]=='*' )
                    {
                        chDisp[i]=chBuf[0];
                        i++;
                        PinPadKey->Text = chDisp;
                    }
                    if ( atoi(szPinLength)>0 )
                    {
                        if ( i>=(atoi(szPinLength)) )
                        {
                            StatusBar1->Panels->Items[1]->Text = "user finish inputting the password ,and then password encryption text can be selected";
                            btGetPin->Enabled = TRUE;
                            btCloseCom->Enabled = TRUE;
                            return;
                        }
                    }
                }
            }
        }
        else
        {
            GetErrStatus(iRet,chErrMsg);
            sprintf(szErr, "failure in starting the PIN,the failure reason is:%s", chErrMsg);
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        }
    }
    else
    {
        InitEnableButton();
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   "failure in selecting function";
    }
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::btGetPinClick(TObject *Sender)
{
    char szPinValue[256]={0},chErrMsg[100]={0},szErr[128]={0};
    char szTemp[64],chKeyNo[3]={0},chKey[49]={0},chMin[49]={0};
    char szKeyNo[10]={0},cpComm[100]={0},szAccount[30]={0};
    int iRet ,iVerifyValue,iPinType,szPinType,iAccountLen;

    iStop = 1;
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    InitDisableButton();
    g_BegainReadPin = 0;
    edPinSerialNo->Text = "";
    edPinRevLength->Text = "";
    edPinRevEncrypt->Text = "";
    PinMingWen->Text = "";
    if (g_fPinpadGetPinValue == NULL)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   "failure in selecting function";
        InitEnableButton();
        return;
    }
    if ( iEnablePinMode == 1 )
    {
        strcpy(szAccount, edAccount->Text.c_str());
        iPinType = comboPinType->ItemIndex ;
        iAccountLen = strlen(szAccount);
        strcpy(szKeyNo, comboPinKeyNo->Text.c_str());
        sscanf(szKeyNo, "%02X", &iVerifyValue);

        if ((iVerifyValue < 48) || (iVerifyValue > 127))
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "invalid PIN key no. value range:30-7F";
            comboPinKeyNo->SetFocus();
            InitEnableButton();
            return;
        }

        switch(iPinType)
        {
            case 0:          //ASCII
                szPinType = 0x40;
            break;
            case 1:          //ISO9564_0
                szPinType = 0x20;
                break;
            case 2:          //ISO9564_1
                szPinType = 0x21;
                break;
            case 3:          //ISO9564_3
                szPinType = 0x23;
                break;
            case 4:          //IBM3624
                szPinType = 0x30;
                break;
            default:
                break;
        }
        if (( iPinType==1 )||( iPinType==3 ))       //ISO9564_0     ISO9564_3
        {
            if ((iAccountLen<4)||(iAccountLen>20))
            {
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "account length range(04-20)";
                InitEnableButton();
                return;
            }
            sprintf(cpComm,"%s%c%s",
                             szKeyNo,
                             szPinType,
                             szAccount );
        }
        else if ( iPinType==2 )         //ISO9564_1
        {
            if ((iAccountLen!=10))
            {
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "transcode no.length must be 10";
                InitEnableButton();
                return;
            }
            sprintf(cpComm,"%s%c%s",
                             szKeyNo,
                             szPinType,
                             szAccount );
        }
        else           //ASCII     IBM3624
        {
             //Կ, pinʽ, ʾ, pin , 
            sprintf(cpComm,"%s%c",
                            szKeyNo,
                            szPinType);
        }
    }
    if ( iEnablePinMode == 0 )
        iRet = g_fPinpadGetPinValue("",0,5,szPinValue);      //ֻȡģ5ʱѾ㹻
    else
    {
        iRet = g_fPinpadGetPinValue(cpComm,strlen(cpComm),5,szPinValue); //ֻȡģ5ʱѾ㹻
    }
    InitEnableButton();
    if (iRet)
    {
        GetErrStatus(iRet,chErrMsg);
        sprintf(szErr, "failure in reading the PIN ,the failure reason is:%s", chErrMsg);
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        return;
    }

    fmTestZt588->btGetPin->Enabled = FALSE;
    memcpy( chKeyNo,comboPinKeyNo->Text.c_str() ,2 );

    GetPrivateProfileString("KEY_ENCRYPT",chKeyNo,"",chKey,100,".\\KeyStock.txt");

    memset(szTemp, 0, sizeof(szTemp));
    memcpy(szTemp,szPinValue, 2);
    edPinSerialNo->Text = szTemp;

    memset(szTemp, 0, sizeof(szTemp));
    memcpy(szTemp,szPinValue+2, 2);
    edPinRevLength->Text = szTemp;

    memset(szTemp, 0, sizeof(szTemp));
    memcpy(szTemp,szPinValue+4, 16);
    g_fPinpadTriUnTriDes( szTemp,chKey,chMin,1 );

    edPinRevEncrypt->Text = szTemp;
    PinMingWen->Text = chMin;

    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in implementation";
}
//---------------------------------------------------------------------------

void gCompressAsc(char *soustr, int len, char *desstr)
{
    int i=0;
    int ch;
    unsigned char tmpstr[2049];

    sprintf( (char *)tmpstr, "%*.*s", len, len, soustr );
    for( i=0; i<(len+1)/2; i++ )
    {
	    sscanf( (const char *)tmpstr+i*2, "%02X", &ch );
	    desstr[i] = ch & 0xFF;
    }
    desstr[i] ='\0';
}

void __fastcall TfmTestZt588::btMakeMACClick(TObject *Sender)
{
    char szKeyIndex[10]={0},szMacData[4096]={0},szSendMacData[4096]={0},szMakeMacRevData[128]={0};
    char chErrMsg[100]={0},szErr[128] = {0};
    int iVerifyValue=0, iMacDataLen, iMacType,iRet = 0,iSendLen=0;

    iStop = 1;
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    InitDisableButton();
    g_BegainReadPin = 0;
    edMakeMacResult->Text = "";
    strcpy(szKeyIndex, comboMakeMacKeyIndex->Text.c_str());

    sscanf(szKeyIndex, "%02X", &iVerifyValue);

    if ((iVerifyValue < 48) || (iVerifyValue > 127))
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "invalid MAC key no. value range:30-7F";
        comboMakeMacKeyIndex->SetFocus();
        InitEnableButton();
        return;
    }

     //Make mac data
    strcpy(szMacData, memoMakeMacData->Text.c_str());
    iMacDataLen = strlen(szMacData);
    if ( iMacDataLen%2!=0 )
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "the HEX  length in calculating MAC data must be even number";
        comboMakeMacKeyIndex->SetFocus();
        InitEnableButton();
        return;
    }
    char chMacBcd[4096]={0};
    gCompressAsc(szMacData,iMacDataLen,chMacBcd);

    if (iMacDataLen <= 0)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "please input the data calculating the MAC";
        memoMakeMacData->SetFocus();
        InitEnableButton();
        return;
    }

    iMacType = comboMacType->ItemIndex;

     //Կ, MAC, MAC
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "MAC calculation,please wait...";
    sprintf(szSendMacData,"%s%d",
                        szKeyIndex,
                        iMacType+1);
    iSendLen = strlen(szSendMacData);
    memcpy(&szSendMacData[iSendLen],chMacBcd,iMacDataLen/2 );
    iSendLen = iSendLen+iMacDataLen/2;
    if (g_fPinpadMakeMac)
    {
        iRet = g_fPinpadMakeMac(szSendMacData,
                                iSendLen,
                                szMakeMacRevData);

        InitEnableButton();
        if (!iRet)
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "MAC calculation ok";
            edMakeMacResult->Text  = szMakeMacRevData;
        }
        else
        {
            GetErrStatus(iRet,chErrMsg);
            sprintf(szErr, "failure in calculating MAC,THE failure reason is :%s", chErrMsg);
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        }
    }
    else
    {
        InitEnableButton();
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "failure in selecting function";
    }
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::btEncryptDataClick(TObject *Sender)
{
    char szKeyIndex[3]={0},szInputData[4096]={0},szSendData[4096]={0},szRevData[4096]={0};
    char chErrMsg[100]={0},szErr[128]={0};
    int iVerifyValue = 0,iArithmetic,iInputDataLen,iRet = 0;

    iStop = 1;
    g_BegainReadPin = 0;
    InitDisableButton();
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    memoOutput->Text = "";
    strcpy(szKeyIndex, comboKeyIndex->Text.c_str());

    sscanf(szKeyIndex, "%02X", &iVerifyValue);
    if ((iVerifyValue < 48) || (iVerifyValue > 127))
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "invalid key no. value range:30-7F";
        comboKeyIndex->SetFocus();
        InitEnableButton();
        return;
    }

       //㷨
    iArithmetic = comboEncryptType->ItemIndex;

       //ȡô
    strcpy(szInputData, memoInputData->Text.c_str());

    iInputDataLen = strlen(szInputData);

    if (iInputDataLen <= 0)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "data which need to encrypted won't be vacant";
        memoInputData->SetFocus();
        InitEnableButton();
        return;
    }

    if ((iInputDataLen % 16) != 0)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "data length which need to encrypted must be 16 times";
        memoInputData->SetFocus();
        InitEnableButton();
        return;
    }

    //Կ, Desģʽ, 
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "Data Encrpytion,please wait...";
    sprintf(szSendData,"%s%d%s",
                      szKeyIndex,
                      iArithmetic+1,
                      szInputData );
    if (g_fPinpadEncryptData)
    {
        iRet = g_fPinpadEncryptData(szSendData,
                                strlen(szSendData),
                                szRevData);

        InitEnableButton();
        if (!iRet)
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "encryption ok";
            memoOutput->Text  = szRevData;
        }
        else
        {
            GetErrStatus(iRet,chErrMsg);
            sprintf(szErr, "encryption failure,the failure reason is:%s", chErrMsg);
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        }
    }
    else
    {
        InitEnableButton();
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   "failure in selecting function";
    }
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::btDecipherDataClick(TObject *Sender)
{
    char szKeyIndex[3]={0},szInputData[2048]={0},szSendData[2048]={0},szRevData[2048]={0};
    char chErrMsg[100]={0},szErr[128] = {0};
    int iVerifyValue=0,iArithmetic,iInputDataLen,iRet = 0;

    iStop = 1;
    g_BegainReadPin = 0;
    InitDisableButton();
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    memoOutput->Text = "";
    strcpy(szKeyIndex, comboKeyIndex->Text.c_str());

    sscanf(szKeyIndex, "%02X", &iVerifyValue);

    if ((iVerifyValue < 48) || (iVerifyValue > 127))
    {
          fmTestZt588->StatusBar1->Panels->Items[1]->Text = "invalid key no. value range:30-7F";
          comboKeyIndex->SetFocus();
          InitEnableButton();
          return;
    }

    //㷨
    iArithmetic = comboEncryptType->ItemIndex;
    iArithmetic+=0x41;

    //ȡô
    strcpy(szInputData, memoInputData->Text.c_str());
    iInputDataLen = strlen(szInputData);
    if (iInputDataLen <= 0)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "data which need to decrypted won't be vacant";
        memoInputData->SetFocus();
        InitEnableButton();
        return;
    }

    if ((iInputDataLen % 16) != 0)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "data length which need to decrypted must be 16 times";
        memoInputData->SetFocus();
        InitEnableButton();
        return;
    }

    //Կ, Desģʽ, 
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "Data Decryptions,please wait...";
    sprintf(szSendData,"%s%c%s",
                        szKeyIndex,
                        iArithmetic,
                        szInputData );

    if (g_fPinpadEncryptData)
    {
        iRet = g_fPinpadEncryptData(szSendData,
                                 strlen(szSendData),
                                 szRevData);
        InitEnableButton();
        if (!iRet)
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "decryption ok";
            memoOutput->Text  = szRevData;
        }
        else
        {
            GetErrStatus(iRet,chErrMsg);
            sprintf(szErr, "decryption failure,the failure reason is:%s", chErrMsg);
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        }
    }
    else
    {
        InitEnableButton();
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   "failure in selecting function";
    }
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::btCleanUpClick(TObject *Sender)
{
      //ܷ
    fmTestZt588->memoOutput->Text = "";

    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    //
    fmTestZt588->memoInputData->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::btCleanUpMacClick(TObject *Sender)
{
    memoMakeMacData->Text = "";
    edPinSerialNo->Text = "";
    edPinRevLength->Text = "";
    PinMingWen->Text = "";
    edPinRevEncrypt->Text = "";
    edMakeMacResult->Text = "";
    PinPadKey->Text = "";
}
//---------------------------------------------------------------------------


void __fastcall TfmTestZt588::btInitAuthorizationClick(TObject *Sender)
{
    int iRet=0,iLen;
    char szRevData[256]={0},szAuthorization[128]={0};
    char chErrMsg[100]={0},szErr[128]={0};

    iStop = 1;
    strcpy(szAuthorization, edAuthorizationData->Text.c_str());
    if ( strlen(szAuthorization)!=32 )
    {
        if (g_fPinpadGetChallenge)
        {
            iRet = g_fPinpadGetChallenge(szAuthorization);

            InitEnableButton();
            if (!iRet)
            {
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "get challenge succeed";
            }
            else
            {
                GetErrStatus(iRet,chErrMsg);
                sprintf(szErr, "get challenge failure,failure reason is:%s", chErrMsg);
                fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
                InitEnableButton();
                return ;
            }
        }
        else
        {
            InitEnableButton();
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   "failure in selecting function";
            return;
        }
    }

    edAuthorizationData->Text = szAuthorization;

    g_BegainReadPin = 0;
    InitDisableButton();
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    iLen = strlen(szAuthorization);
    if ((iLen <= 0)  || (iLen != 16*2))
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "authorization  data must be 16-bytes";
        edAuthorizationData->SetFocus();
        InitEnableButton();
        return;
    }

    if (g_fPinpadInitAuthorization)
    {
        iRet = g_fPinpadInitAuthorization(szAuthorization,
                                          iLen,
                                          szRevData);

        InitEnableButton();
        if (!iRet)
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "initial authorization succeed";
            SaveKey("INIT_AUTH", "AUTH", szRevData);
        }
        else
        {
              GetErrStatus(iRet,chErrMsg);
              sprintf(szErr, " initial authorization failure,failure reason is:%s", chErrMsg);
              fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        }
    }
    else
    {
        InitEnableButton();
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   "failure in selecting function";
    }
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::btBidirectionAuthorizationClick(
      TObject *Sender)
{
    char szKeyIndex[3]={0},chKeyNo1[10]={0},chKeyTmp[49]={0},szAuthorization[128]={0};
    char chErrMsg[100]={0},szErr[128]={0};//,chKey[49]={0};
    char szRevData[256]={0},szInitRevData[128]={0};
    int iRet=0,iLen;

    iStop = 1;
    g_BegainReadPin = 0;
    InitDisableButton();
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    strcpy( szAuthorization,edAuthorizationData->Text.c_str() );

    if (g_fPinpadGetChallenge)
    {
        iRet = g_fPinpadGetChallenge(szInitRevData);

        InitEnableButton();
        if (!iRet)
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "get challenge succeed";
        }
        else
        {
              GetErrStatus(iRet,chErrMsg);
              sprintf(szErr, "get challenge failure,failure reason is:%s", chErrMsg);
              fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
              InitEnableButton();
              return ;
        }
    }
    else
    {
        InitEnableButton();
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   "failure in selecting function";
        return;
    }
    AuthRandom->Text = szInitRevData;
    strcpy( szInitRevData,AuthRandom->Text.c_str() );

    iLen = strlen(szInitRevData);
    if ((iLen <= 0)  || (iLen != 16*2))
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "authorization  data must be 16-bytes";
        edAuthorizationData->SetFocus();
        InitEnableButton();
        return;
    }

    strcpy(szKeyIndex, ComboInitKey->Text.c_str() );
    sprintf( chKeyNo1,"%s_1",szKeyIndex );
    GetPrivateProfileString( "KEY_MINWEN",chKeyNo1,"",chKeyTmp,49,".\\KeyStock.txt");
    if ( strlen( chKeyTmp)==0 )
    {
        GetPrivateProfileString( "KEY_ENCRYPT",szKeyIndex,"",chKeyTmp,49,".\\KeyStock.txt");
        if ( strlen(chKeyTmp)==0 )
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "matched key which hasn't been downloaded,please download the matched key";
            InitEnableButton();
            return;
        }
    }

    if (g_fPinpadBidirectionalAuthorization)
    {
        iRet = g_fPinpadBidirectionalAuthorization(szAuthorization,
                                                   iLen,
                                                   szKeyIndex, //  key index
                                                   szInitRevData,
                                                   szRevData);

        InitEnableButton();
        if (!iRet)
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "bi-directonal authorization ok";
            edReturnAuthorization->Text  = szRevData;
        }
        else
        {
            GetErrStatus(iRet,chErrMsg);
            sprintf(szErr, "bi-directonal authorization failure,failure reason is:%s", chErrMsg);
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        }
    }
    else
    {
        InitEnableButton();
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "failure in selecting function";
    }
}
//---------------------------------------------------------------------------


void __fastcall TfmTestZt588::btGetCustomerInforClick(TObject *Sender)
{
    char szData[256],chErrMsg[100]={0},szErr[128]={0},szErrCode[128];
    int iRet;

    iStop = 1;
    g_BegainReadPin = 0;
    InitDisableButton();
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    memset(szData, 0, sizeof(szData));
    memset(szErrCode, 0, sizeof(szErrCode));

    if (g_fPinpadGetCustomerInfo == NULL)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "failure in selecting function";
        InitEnableButton();
        return;
    }

    iRet = g_fPinpadGetCustomerInfo(szData);

    InitEnableButton();
    if (iRet)
    {
        GetErrStatus(iRet,chErrMsg);
        if ( iRet!=0xe0 )
        {
            sprintf(szErr, "fail in reading user information,the failure reason is:%s", chErrMsg);
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
            return;
        }
        else
        {
            sprintf(szErr, "read user information:%s", chErrMsg);
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        }
    }
    else
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "implementation ok";

    char chUserInfo[51]={0};
    memcpy( chUserInfo,szData,50 );
    memoGetCustInfo->Text = chUserInfo;
    memoCustInof->Text = chUserInfo;
    char chMKeyValue[33]={0},chLeftValue[17]={0},chRightValue[17]={0};
    memcpy( chMKeyValue,szData+50,32 );
    memcpy( chLeftValue,szData+50+32,8 );
    memcpy( chRightValue,szData+50+40,8 );
    edKeyboardMainValue->Text = chMKeyValue;
    edLeftKey->Text = chLeftValue;
    edRightKey->Text = chRightValue;
}
//---------------------------------------------------------------------------


void __fastcall TfmTestZt588::btSetKeyboardClick(TObject *Sender)
{
    char szData[256],szErrCode[128],szMainKeyValue[33]={0},szLeftKey[9]={0};
    char szRightKey[9]={0},chErrMsg[100]={0},szErr[128]={0};
    int iMainKeyLen,iLeftLen,iRightLen,iRet;

    iStop = 1;
    g_BegainReadPin = 0;
    InitDisableButton();
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    memset(szData, 0, sizeof(szData));
    memset(szErrCode, 0, sizeof(szErrCode));

    strcpy(szMainKeyValue, edKeyboardMainValue->Text.c_str());
    strcpy(szLeftKey, edLeftKey->Text.c_str());
    strcpy(szRightKey, edRightKey->Text.c_str());

    iMainKeyLen = strlen(szMainKeyValue);
    iLeftLen = strlen(szLeftKey);
    iRightLen = strlen(szRightKey);

    if (iMainKeyLen != 32)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "master keyboard value  must be 32-HEX character";
        edKeyboardMainValue->SetFocus();
        InitEnableButton();
        return;
    }
    if (iLeftLen != 8)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "left function  keyboard value must be 8-HEX character";
        edLeftKey->SetFocus();
        InitEnableButton();
        return;
    }
    if (iRightLen != 8)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "wrong right  function  keyboard value must be 8-HEX character";
        edRightKey->SetFocus();
        InitEnableButton();
        return;
    }
    sprintf(szData, "%s%s%s", szMainKeyValue, szLeftKey, szRightKey);

    if (g_fPinpadSetKeyboardValue == NULL)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "failure in selecting function";
        InitEnableButton();
        return;
    }

    iRet = g_fPinpadSetKeyboardValue(szData, strlen(szData));
    InitEnableButton();
    if (iRet)
    {
        GetErrStatus(iRet,chErrMsg);
        sprintf(szErr, "failure in setting keyboard value,the failure reason is:%s", chErrMsg);
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        return;
    }
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in setting the keyboard value";
}
//---------------------------------------------------------------------------


void __fastcall TfmTestZt588::btSetControlCodeClick(TObject *Sender)
{
    char szData[256],szErrCode[128],szControlCode[3]={0},chTemp[3]={0};
    char chErrMsg[100]={0},szErr[128]={0};
    int nKeyCode,iControlType,iRet;

    iStop = 1;
    memset(szData, 0, sizeof(szData));
    memset(szErrCode, 0, sizeof(szErrCode));
    g_BegainReadPin = 0;
    InitDisableButton();
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";

    iControlType = comboControlCode->ItemIndex;
    strcpy(szControlCode, edControlCode->Text.c_str());

    if (strlen(szControlCode) != 2)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "control code value must be 2-HEX character";
        comboControlCode->SetFocus();
        InitEnableButton();
        return;
    }
    strcpy(chTemp, edControlCode->Text.c_str());
    sscanf( chTemp,"%02X",&nKeyCode );
    if ( iControlType==1 )
    {
        if ( RadioGroup1->ItemIndex==0 )
        {
            sprintf( szControlCode,"%02X",nKeyCode );
        }
        else
        {
            nKeyCode+=0x80;
            sprintf( szControlCode,"%02X",nKeyCode );
        }
    }
    else
        sprintf( szControlCode,"%02X",nKeyCode );

    if (iControlType==10)
        sprintf(szData, "A%s", szControlCode);
    else if (iControlType==11)
        sprintf(szData, "B%s", szControlCode);
    else
        sprintf(szData, "%d%s", iControlType, szControlCode);
//    sprintf(szData, "%d%s", iControlType, szControlCode);

    if (g_fPinpadSetControlCode == NULL)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "failure in selecting function";
        InitEnableButton();
        return;
    }

    iRet = g_fPinpadSetControlCode(szData, strlen(szData));

    if (iRet)
    {
        GetErrStatus(iRet,chErrMsg);
        sprintf(szErr, "failure in setting the control code,failure reason is:%s", chErrMsg);
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        InitEnableButton();
        return;
    }

    if (( iControlType==6 ) && ((nKeyCode>=0x41)&&(nKeyCode<=0x48)))
    {
        g_fPinpadDisable();
        comboBoundRate->ItemIndex = nKeyCode-0x41;
        char szPort[10],szParity[12],szBite[12],szStopBite[5];
        long lBoundRate = 0;
        int  iRet = 0;

        g_BegainReadPin = 0;
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
        memset(szPort, 0 , sizeof(szPort));
        memset(szParity, 0, sizeof(szParity));
        memset(szBite, 0, sizeof(szBite));
        memset(szStopBite, 0, sizeof(szStopBite));

        strcpy(szPort, comboPort->Text.c_str());
        lBoundRate = comboBoundRate->Text.ToInt();

        strcpy(szParity, comboParity->Text.c_str());
        if (!memcmp(szParity, "NO", 2))
        {
            szParity[0] = 'N';
        }
        else
        {
            szParity[0] = 'Y';
        }

        strcpy(szBite,  comboDataBit->Text.c_str());
        strcpy(szStopBite,  comboStop->Text.c_str());

        if (g_fPinpadEnable != NULL)
        {
            iRet = g_fPinpadEnable(szPort,
                                lBoundRate,
                                szParity,
                                szBite,
                                szStopBite);
        }

        if (iRet)
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "set the control code ok but fail in opening the serial port";
        }
        else
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "set the control code ok and succeed in opening the serial";
            InitEnableButton();
        }
    }
    else
    {
        if ( iControlType==2 )
        {
            int iTimeOut;
            char cpTime[100]={0};
            sscanf( szControlCode,"%02X",&iTimeOut );
            sprintf( cpTime,"%d",iTimeOut );
            WritePrivateProfileString("PINRENEW", "TIMEOUT", cpTime, ".\\KeyStock.txt");
        }
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "set the control code ok";
        InitEnableButton();
    }
}
//---------------------------------------------------------------------------


void __fastcall TfmTestZt588::comboEncryptMarkChange(TObject *Sender)
{
    int i,nNum;
    char chNo[3]={0};

//    comboDecipherNo->Enabled = TRUE;
//    comboEnryptLength->Enabled = TRUE;
//    edInputKeyToEncrypt->Enabled = TRUE;
    comboDecipherNo->Enabled = TRUE;
    comboEnryptLength->Enabled = TRUE;
    edInputKeyToEncrypt->Enabled = TRUE;
    edEncrypKey->Enabled = TRUE;
    if ( memcmp(comboEncryptMark->Text.c_str(),"TMK",3)==0 )
    {
        memcpy(chNo,comboEncryptNo->Text.c_str(),2);
        comboEncryptNo->Clear() ;
        sscanf(chNo,"%02X",&nNum);
        if ( nNum>0x3f )
            comboEncryptNo->Text = "10";
        else
            comboEncryptNo->Text = chNo;
        for ( i=16;i<64;i++ )
        {
            sprintf( chNo,"%02X",i );
            comboEncryptNo->Items->Add(chNo);
        }
        return;
    }
    else if (memcmp(comboEncryptMark->Text.c_str(),"TDSK",4)==0)
    {
        comboDecipherNo->Enabled = TRUE;
        comboEnryptLength->Enabled = TRUE;
        edInputKeyToEncrypt->Enabled = TRUE;
        edEncrypKey->Enabled = TRUE;
        memcpy(chNo,comboEncryptNo->Text.c_str(),2);
        comboEncryptNo->Clear() ;
        sscanf(chNo,"%02X",&nNum);
        if ( nNum<0x40 )
            comboEncryptNo->Text = "40";
        else
            comboEncryptNo->Text = chNo;
        for ( i=64;i<128;i++ )
        {
            sprintf( chNo,"%02X",i );
            comboEncryptNo->Items->Add(chNo);
        }
        return;
    }
    else if (memcmp(comboEncryptMark->Text.c_str(),"NOK",3)==0)
    {
        comboDecipherNo->Enabled = FALSE;
        comboEnryptLength->Enabled = FALSE;
        edInputKeyToEncrypt->Enabled = FALSE;
        edInputKeyToEncrypt->Text = "";
        edEncrypKey->Text = "";
        edEncrypKey->Enabled = FALSE;
        memcpy(chNo,comboEncryptNo->Text.c_str(),2);
        comboEncryptNo->Clear() ;
        sscanf(chNo,"%02X",&nNum);
        if ( nNum<0x20 )
            comboEncryptNo->Text = "20";
        else
            comboEncryptNo->Text = chNo;
        for ( i=32;i<128;i++ )
        {
            sprintf( chNo,"%02X",i );
            comboEncryptNo->Items->Add(chNo);
        }
        return;
    }
    else
    {
       memcpy(chNo,comboEncryptNo->Text.c_str(),2);
        comboEncryptNo->Clear() ;
        sscanf(chNo,"%02X",&nNum);
        if ( nNum<0x30 )
            comboEncryptNo->Text = "30";
        else
            comboEncryptNo->Text = chNo;
        for ( i=48;i<128;i++ )
        {
            sprintf( chNo,"%02X",i );
            comboEncryptNo->Items->Add(chNo);
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::comboKeyNoChange(TObject *Sender)
{
    char chKey1[49]={0},chKey2[49]={0},chKey3[49]={0};
    char chTemp[10]={0},chKeyNo[3]={0};

    memcpy( chKeyNo,comboKeyNo->Text.c_str(),2 );
    sprintf( chTemp,"%s_1",chKeyNo );
    GetPrivateProfileString("KEY_MINWEN",chTemp,"",chKey1,100,".\\KeyStock.txt");
    edPin1->Text = chKey1;

    sprintf( chTemp,"%s_2",chKeyNo );
    GetPrivateProfileString("KEY_MINWEN",chTemp,"",chKey2,100,".\\KeyStock.txt");
    edPin2->Text = chKey2;
    sprintf( chTemp,"%s_3",chKeyNo );
    GetPrivateProfileString("KEY_MINWEN",chTemp,"",chKey3,100,".\\KeyStock.txt");
    edPin3->Text = chKey3;
    if ((strlen(chKey1)>0)&&(strlen(chKey2)>0)&&(strlen(chKey3)>0))
    {
        edPin1->Enabled = TRUE;
        edPin2->Enabled = TRUE;
        edPin3->Enabled = TRUE;
        comboMixCode->ItemIndex = 1;
    }
    else if ((strlen(chKey1)>0)&&(strlen(chKey2)>0))
    {
        edPin1->Enabled = TRUE;
        edPin2->Enabled = TRUE;
        comboMixCode->ItemIndex = 2;
    }
    else
        comboMixCode->ItemIndex = 0;

    if ( comboMixCode->ItemIndex !=2 )
    {
        if ( strlen(chKey1)==16 )
            comboPinLength->ItemIndex = 0;
        else if ( strlen(chKey1)==32 )
            comboPinLength->ItemIndex = 1;
        else
            comboPinLength->ItemIndex = 2;
    }
    else
    {
        if ( strlen(chKey1)==8 )
            comboPinLength->ItemIndex = 0;
        else if ( strlen(chKey1)==16 )
            comboPinLength->ItemIndex = 1;
        else
            comboPinLength->ItemIndex = 2;
    }
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::comboEncryptNoChange(TObject *Sender)
{
    char chKey[49]={0};
    char chKeyNo[3]={0};

    memcpy( chKeyNo,comboEncryptNo->Text.c_str(),2 );
    GetPrivateProfileString("KEY_ENCRYPT",chKeyNo,"",chKey,100,".\\KeyStock.txt");
    edInputKeyToEncrypt->Text = chKey;
    if ( strlen(chKey)==32 )
        comboEnryptLength->ItemIndex = 1;
    else if ( strlen(chKey)==48 )
        comboEnryptLength->ItemIndex = 2;
    else
        comboEnryptLength->ItemIndex = 0;
}
//---------------------------------------------------------------------------



void __fastcall TfmTestZt588::Timer1Timer(TObject *Sender)
{
    fmTestZt588->StatusBar1->Panels->Items[2]->Text = Now().TimeString() ;
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::Button1Click(TObject *Sender)
{
    edProductType->Text = "";
    edHardwareVersion->Text = "";
    edSoftwareVersion->Text = "";
    edDate->Text = "";
    edProductNO->Text = "";
    edRemark->Text = "";
    edAuthorizationData->Text = "";
    edReturnAuthorization->Text = "";
}
//---------------------------------------------------------------------------





void __fastcall TfmTestZt588::comboPinTypeChange(TObject *Sender)
{
    int iValue = comboPinType->ItemIndex ;
    char chPinLen[10]={0};
    switch(iValue)
    {
        case 0:
            edAccount->Enabled = FALSE;
            edPinLength->Items->Clear() ;
            edPinLength->Text = "06";
            for ( int i=0x00;i<=0x08;i++ )
            {
                sprintf( chPinLen,"%02d",i );
                edPinLength->Items->Add(chPinLen);
            }
            break;
        case 1:
        case 3:
            edAccount->Enabled = TRUE;
            edAccount->MaxLength = 20;
            edPinLength->Items->Clear() ;
            edPinLength->Text = "06";
            for ( int i=0x00;i<=0x0C;i++ )
            {
                sprintf( chPinLen,"%02d",i );
                edPinLength->Items->Add(chPinLen);
            }
            break;
        case 2:
            edAccount->Enabled = TRUE;
            edAccount->MaxLength = 10 ;
            if ( strlen(edAccount->Text.c_str())>10 )
            {
                 char chTmp[11]={0};
                 memcpy( chTmp,edAccount->Text.c_str(),10 );
                 edAccount->Text = chTmp;
            }
            edPinLength->Items->Clear() ;
            edPinLength->Text = "06";
            for ( int i=0x00;i<=0x0C;i++ )
            {
                sprintf( chPinLen,"%02d",i );
                edPinLength->Items->Add(chPinLen);
            }
            break;
        case 4:
            edAccount->Enabled = FALSE;
            edPinLength->Items->Clear() ;
            edPinLength->Text = "06";
            for ( int i=0x00;i<=0x10;i++ )
            {
                sprintf( chPinLen,"%02d",i );
                edPinLength->Items->Add(chPinLen);
            }
            break;
        default:
            break;
    }
}
//---------------------------------------------------------------------------





void __fastcall TfmTestZt588::IC_ControlClick(TObject *Sender)
{
    char chErrMsg[100]={0},szErr[128]={0};
    char cpCommand[100]={0},cpCard[10]={0},cpAtr[256]={0};
    int iRet,iSock,iControl;

    iStop = 1;
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    CardAtr->Text = "";
    if (g_fPinPad_IC_Control == NULL)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "failure in selecting function";
        InitEnableButton();
        return;
    }
    iSock = CardSockt1->Text.ToInt() ;
    if (strcmp(CardType->Text.c_str(),"CPU")==0 )
        strcpy( cpCard,"88" );
    else
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "Select Card Type Error";
        return;
    }

    if (strcmp(ControlCode->Text.c_str(),"PowerOn")==0 )
        iControl = 1;
    else if (strcmp(ControlCode->Text.c_str(),"GetStatus")==0 )
        iControl = 2;
    else if (strcmp(ControlCode->Text.c_str(),"PowerDown")==0 )
        iControl = 3;
    else
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "Select Control Code Error";
        return;
    }

    InitDisableButton();
    sprintf( cpCommand,"%d%s%d",iSock,cpCard,iControl );
    iRet = g_fPinPad_IC_Control(cpCommand, cpAtr);


    if (iRet)
    {
        GetErrStatus(iRet,chErrMsg);
        sprintf(szErr, "failure in IC Card Control,failure reason is:%s", chErrMsg);
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        InitEnableButton();
        return;
    }
    InitEnableButton();
    CardAtr->Text = cpAtr;
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "IC Card Control Success";
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::IC_AccessClick(TObject *Sender)
{
    char chErrMsg[100]={0},szErr[128]={0};
    char cpCommand[1024]={0};
    char cpRcv[1024]={0},cpData[1024]={0},cpSw[5]={0};
    int iRet,iLe,iLc,iSock;

    iStop = 1;
    DataRcv->Text = "";
    RcvSW->Text = "";
    g_BegainReadPin = 0;
    if (g_fPinPad_IC_Access == NULL)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "failure in selecting function";
        InitEnableButton();
        return;
    }
    sscanf( LE->Text.c_str(),"%02X",&iLe );
    sscanf( LC->Text.c_str(),"%02X",&iLc );
    if (strlen(LE->Text.c_str())==0)
        iLe = 0;
    if (strlen(LC->Text.c_str())==0)
        iLc = 0;

    iSock = CardSockt2->Text.ToInt() ;
    if ( iLc!=0 && iLe!=0 )
    {
         if ( (int)strlen(DataSend->Text.c_str())!=(iLc*2) )
         {
             fmTestZt588->StatusBar1->Panels->Items[1]->Text = "APDU Data Length Error";
             return;
         }
         sprintf( cpCommand,"%d%s%s%s%s%s%s%s",iSock,CLA->Text.c_str(),INS->Text.c_str(),P1->Text.c_str(),P2->Text.c_str(),LC->Text.c_str(),DataSend->Text.c_str(),LE->Text.c_str() );
    }
    else if ( iLc!=0 )
    {
         if ( (int)strlen(DataSend->Text.c_str())!=(iLc*2) )
         {
             fmTestZt588->StatusBar1->Panels->Items[1]->Text = "APDU Data Length Error";
             return;
         }
         sprintf( cpCommand,"%d%s%s%s%s%s%s",iSock,CLA->Text.c_str(),INS->Text.c_str(),P1->Text.c_str(),P2->Text.c_str(),LC->Text.c_str(),DataSend->Text.c_str());
    }
    else if ( iLe!=0 )
    {
         sprintf( cpCommand,"%d%s%s%s%s%s",iSock,CLA->Text.c_str(),INS->Text.c_str(),P1->Text.c_str(),P2->Text.c_str(),LE->Text.c_str());
    }
    else
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "LC Or LE Data Error";
        return;
    }

    iRet = g_fPinPad_IC_Access(cpCommand, cpRcv);
    if (iRet)
    {
        GetErrStatus(iRet,chErrMsg);
        sprintf(szErr, "failure in IC Card Accessing,failure reason is: %s", chErrMsg);
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        InitEnableButton();
        return;
    }
    InitEnableButton();
    memcpy( cpData,cpRcv,strlen(cpRcv)-4 );
    memcpy( cpSw,&cpRcv[strlen(cpRcv)-4],4 );
    DataRcv->Text = cpData;
    RcvSW->Text = cpSw;
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "IC Card Accessing Success";
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::ClearIcClick(TObject *Sender)
{
    DataRcv->Text = "";
    CardAtr->Text = "";
    RcvSW->Text = "";        
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::OpenKeyBordClick(TObject *Sender)
{
    char chErrMsg[100]={0},szErr[128]={0};
    int iRet;

    if (g_fPinpadSetControlCode == NULL)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "failure in selecting function";
        InitEnableButton();
        return;
    }

    iRet = g_fPinpadSetControlCode("035", 3);
    if (iRet)
    {
        GetErrStatus(iRet,chErrMsg);
        sprintf(szErr, "failure in Open Pinpad,failure reason is:%s", chErrMsg);
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = szErr;
        return;
    }
    iRet = g_fPinpadSetControlCode("033", 3);
    if (iRet)
    {
        GetErrStatus(iRet,chErrMsg);
        sprintf(szErr, "failure in Open Pinpad,failure reason is:%s", chErrMsg);
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        return;
    }
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "Open Pinpad Success,Please Key-press";

    OpenKeyBord->Enabled = FALSE;
    btOpenCom->Enabled = FALSE;
    btCloseCom->Enabled = FALSE;
    btGetVersion->Enabled = FALSE;
    btInitAuthorization->Enabled = FALSE;
    btBidirectionAuthorization->Enabled = FALSE;
    btSetCustomerInfo->Enabled = FALSE;
    btGetCustomerInfor->Enabled = FALSE;
    btSetKeyboard->Enabled = FALSE;
    btSetControlCode->Enabled = FALSE;
    btDownloadKey->Enabled = FALSE;
    btDownloadEncrypt->Enabled = FALSE;
    btEnablePin->Enabled = FALSE;
    btGetPin->Enabled = FALSE;
    btMakeMAC->Enabled = FALSE;
    btEncryptData->Enabled = FALSE;
    btDecipherData->Enabled = FALSE;
    OpenKeyBord->Enabled = FALSE;
    CloseKeyBord->Enabled = TRUE;


    iStop = 0;
    g_BegainReadPin = 1;
    MSG Message;
    char chDisp[100]={0},chBuf[10];
    int i=0;
    while(1)
    {
        if( ::PeekMessage(&Message,NULL,0,0,PM_REMOVE) ) {
	    ::TranslateMessage(&Message);
	    ::DispatchMessage(&Message);
	} //˴ǣٵʱ滹ʾ
        if ( g_BegainReadPin == 0 )
            break;
        if ( iStop == 1 )
            break;
        memset( chBuf,'\0',sizeof(chBuf) );
        iRet = g_fPinpadReadOneByte( chBuf );
        if ( iRet>0 )
        {
            i++;
            if ( i>300 )
            {
                Memo1->Text = "";
                Memo2->Text = "";
                i = 0;
            }
            Memo1->Text = Memo1->Text+chBuf[0];
            memset( chDisp,'\0',sizeof(chDisp) );
            sprintf( chDisp,"%02X ",chBuf[0]&0xFF );
            Memo2->Text = Memo2->Text+chDisp ;
        }
    }
    InitEnableButton();
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::CloseKeyBordClick(TObject *Sender)
{
    char chErrMsg[100]={0},szErr[128]={0};
    int iRet;

    iStop = 1;
    g_BegainReadPin = 0;
    if (g_fPinpadSetControlCode == NULL)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "failure in selecting function";
        InitEnableButton();
        return;
    }

    iRet = g_fPinpadSetControlCode("032", 3);
    if (iRet)
    {
        GetErrStatus(iRet,chErrMsg);
        sprintf(szErr, "failure in Close Pinpad,failure reason is:%s", chErrMsg);
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        InitEnableButton();
        return;
    }
    InitEnableButton();
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "Close Pinpad Success";
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::Button2Click(TObject *Sender)
{
    Memo1->Text = "";
    Memo2->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::Button4Click(TObject *Sender)
{
    char szDownloadKey[256] = {0};
    char chKeyNo[10]={0};  //chMKey[49]={0},chMKey1[49]={0},chVer[9]={0},chMKey2[49]={0},chMKey3[49]={0},chTemp[49]={0},
    char szRevData[128]={0},chKeyTmp[49]={0},chErrMsg[100]={0},szErr[128]={0};
       //Կ  comboDecipherNo
    char szDecipherNo[20] = {0};
      //Կ comboEncryptNo
    char szSaveKeyNo[20] = {0};
    unsigned char chDecipher[128]={0};
    int iVerifyValue = 0, iRet = 0;       // 

      //Կȴ
//    int iKeyLength = comboEnryptLength->ItemIndex;
/*
      //Կǩ
    int iEncryptKeyMark;
    
    if ( comboEncryptMark->ItemIndex>=2 )
        iEncryptKeyMark = comboEncryptMark->ItemIndex+1;
    else iEncryptKeyMark = comboEncryptMark->ItemIndex;
*/
    iStop = 1;
    g_BegainReadPin = 0;
    Edit15->Text = "";
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    InitDisableButton();
    Edit15->Text = "";

    strcpy(szDecipherNo, comboDecipherNo->Text.c_str());
    strcpy(szSaveKeyNo, comboEncryptNo->Text.c_str());

    if (strlen(szDecipherNo) <= 0)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "decryption key no.won't be vacantvalue range:00-3F";
        comboDecipherNo->SetFocus();
        InitEnableButton();
        return;
    }

    if (strlen(szSaveKeyNo) <= 0)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "save key no.won't be vacant value range:00-7F";
        comboDecipherNo->SetFocus();
        InitEnableButton();
        return;
    }
    else
    {
        sscanf(szSaveKeyNo, "%02X", &iVerifyValue);
        if ((iVerifyValue < 0) || (iVerifyValue > 127))
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "invalid decryption key no value range:00-7F";
            comboEncryptNo->SetFocus();
            InitEnableButton();
            return;
        }
    }

    //ԿţԿţԿǩţԿȣԿЧֵ
    sprintf(szDownloadKey, "%s%s%d%d",
                           szDecipherNo,
                           szSaveKeyNo,
                           0,
                           0);

    if (g_fPinpadDownloadEncryptKey)
    {
        iRet = g_fPinpadDownloadEncryptKey(szDownloadKey,
                                           strlen(szDownloadKey),
                                           szRevData);
        InitEnableButton();
        if (!iRet)
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in Read Key Verify Code";
            Edit15->Text = szRevData;

            //save the key
            SaveKey("KEY_ENCRYPT", szSaveKeyNo, chDecipher);

            if ( memcmp(szSaveKeyNo,szDecipherNo,2)==0 )
            {
                sprintf( chKeyNo,"%s_1",szDecipherNo );
                GetPrivateProfileString( "KEY_MINWEN",chKeyNo,"",chKeyTmp,49,".\\KeyStock.txt");
                if ( strlen(chKeyTmp)>0 )
                {
                    SaveKey("KEY_MINWEN", chKeyNo, "");
                    sprintf( chKeyNo,"%s_2",szDecipherNo );
                    SaveKey("KEY_MINWEN", chKeyNo, "");
                    sprintf( chKeyNo,"%s_3",szDecipherNo );
                    SaveKey("KEY_MINWEN", chKeyNo, "");
                }
            }
            char chTmp[20]={0};
            strcpy( chTmp,comboEncryptMark->Text.c_str() );
            int nNum;
            sscanf(szSaveKeyNo,"%02X",&nNum);
            if ( nNum<=0x1f )
            {
                if ( strcmp(chTmp,"TMK")==0 )
                {
                    sprintf( chKeyNo,"%s_1",szSaveKeyNo );
                    SaveKey("KEY_MINWEN", chKeyNo, chDecipher);
                    sprintf( chKeyNo,"%s_2",szSaveKeyNo );
                    SaveKey("KEY_MINWEN", chKeyNo, "");
                    sprintf( chKeyNo,"%s_3",szSaveKeyNo );
                    SaveKey("KEY_MINWEN", chKeyNo, "");
                }
            }
        }
        else
        {
            GetErrStatus(iRet,chErrMsg);
            Edit15->Text = "";
            sprintf(szErr, "failure in Read Key Verify Code,thefailure reason is:%s", chErrMsg);
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        }
    }
    else
    {
        InitEnableButton();
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   "failure in selecting function PinPad_DownloadEncryptKey()";
    }
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::Button5Click(TObject *Sender)
{
    char szHintCode[50]={0},szPinLength[5]={0};
    char szEnablePin[256]={0},chErrMsg[100]={0},szErr[128]={0};
    int iAccountLen,iRet = 0;

    iStop = 0;
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    InitDisableButton();
    PinPadKey->Text = "";
    edPinSerialNo->Text = "";
    edPinRevLength->Text = "";
    edPinRevEncrypt->Text = "";
    PinMingWen->Text = "";
    memcpy(szHintCode, comboHintAudio->Text.c_str(),1);
    memcpy(szPinLength, edPinLength->Text.c_str(),2);

    char cpCRCode[10]={0},cpClear[10]={0};
    memcpy( cpCRCode,ComboBox1->Text.c_str(),1 );
    memcpy( cpClear,ComboBox2->Text.c_str(),1 );
    int iClear = atoi(cpClear);
    sprintf(szEnablePin,"%s%s%s%s",
                             szHintCode,
                             szPinLength,
                             cpCRCode,
                             cpClear );

    if (g_fPinpadEnablePin)
    {
        iRet = g_fPinpadEnablePin(szEnablePin,
                                  strlen(szEnablePin));

        iEnablePinMode = 1;
        InitEnableButton();
        if (!iRet)
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in starting PIN ,please input your password in the keyboard";
            fmTestZt588->btGetPin->Enabled = FALSE;
            g_BegainReadPin = 1;
            MSG Message;
            char chDisp[100]={0},chBuf[10];
            int i=0;
            btCloseCom->Enabled = FALSE;
            while(1)
            {
		if( ::PeekMessage(&Message,NULL,0,0,PM_REMOVE) ) {
			::TranslateMessage(&Message);
			::DispatchMessage(&Message);
		} //˴ǣٵʱ滹ʾ
                if ( g_BegainReadPin == 0 )
                {
                    btCloseCom->Enabled = TRUE;
                    return;
                }
                if ( iStop==1 )
                    break;
                memset( chBuf,'\0',sizeof(chBuf) );
                iRet = g_fPinpadReadOneByte( chBuf );
                if ( iRet>0 )
                {
                    if ( chBuf[0]==0x08 )
                    {
                        if ((iClear==2)||(iClear==6))
                        {
                            i=0;
                            memset( chDisp,'\0',sizeof(chDisp));
                            PinPadKey->Text = chDisp;
                            continue;
                        }
                        else
                        {
                            i--;
                            chDisp[i]='\0';
                            PinPadKey->Text = chDisp;
                            continue;
                        }
                    }
                    if ( chBuf[0]==0x1B )
                    {
                        memset( chDisp,'\0',sizeof(chDisp));
                        StatusBar1->Panels->Items[1]->Text = "user has cancelled  the password input";
                        btCloseCom->Enabled = TRUE;
                        return;
                    }
                    if ( chBuf[0]==0x0d )
                    {
                        StatusBar1->Panels->Items[1]->Text = "user finish inputting the password ,and then password encryption text can be selected";
                        btGetPin->Enabled = TRUE;
                        btCloseCom->Enabled = TRUE;
                        return;
                    }
                    if ( chBuf[0]=='*' )
                    {
                        chDisp[i]=chBuf[0];
                        i++;
                        PinPadKey->Text = chDisp;
                    }
                    if ( atoi(szPinLength)>0 )
                    {
                        if ( i>=(atoi(szPinLength)) )
                        {
                            StatusBar1->Panels->Items[1]->Text = "user finish inputting the password ,and then password encryption text can be selected";
                            btGetPin->Enabled = TRUE;
                            btCloseCom->Enabled = TRUE;
                            return;
                        }
                    }
                }
            }
        }
        else
        {
            GetErrStatus(iRet,chErrMsg);
            sprintf(szErr, "failure in starting the PIN,the failure reason is:%s", chErrMsg);
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        }
    }
    else
    {
        InitEnableButton();
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   "failure in selecting function";
    }
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::ComboBox3Change(TObject *Sender)
{
    int iType = ComboBox3->Text.ToInt() ;
    if ( iType==61 )
    {
        Edit1->Enabled = TRUE;
        Edit2->Enabled = FALSE;
        Edit1->MaxLength = 4;
        char cpTmp[10]={0};
        memcpy( cpTmp,Edit1->Text.c_str(),4 );
        cpTmp[4] = '\0';
        Edit1->Text = cpTmp;
        Edit2->Text = "";
    }
    else
    {
        Edit1->Enabled = FALSE;
        Edit2->Enabled = FALSE;
        Edit1->Text = "";
        Edit2->Text = "";
    }
    
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::Button6Click(TObject *Sender)
{
    char szPinValue[256]={0},chErrMsg[100]={0},szErr[128]={0};
    char szTemp[64],szPinLength[10]={0};
    char szKeyNo[10]={0},cpComm[100]={0},szAccount[30]={0},szAccount1[30]={0};
    int iRet ,iVerifyValue,iPinType,szPinType,iAccountLen,iAccountLen1;

    iStop = 1;
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    InitDisableButton();
    g_BegainReadPin = 0;
    edPinSerialNo->Text = "";
    edPinRevLength->Text = "";
    edPinRevEncrypt->Text = "";
    PinMingWen->Text = "";
    if (g_fPinpadGetPinValue == NULL)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   "failure in selecting function";
        InitEnableButton();
        return;
    }
    strcpy(szPinLength, edPinLength->Text.c_str());
    strcpy( szAccount,Edit1->Text.c_str() );
    strcpy( szAccount1,Edit2->Text.c_str() );
    iAccountLen = strlen(szAccount);
    iPinType = ComboBox3->ItemIndex ;
    strcpy(szKeyNo, comboPinKeyNo->Text.c_str());
    sscanf(szKeyNo, "%02X", &iVerifyValue);
    if ((iVerifyValue < 48) || (iVerifyValue > 127))
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "invalid PIN key no. value range:30-7F";
        comboPinKeyNo->SetFocus();
        InitEnableButton();
        return;
    }
    switch(iPinType)
    {
        case 0:
            szPinType = 0x61;
            break;
        default:
            break;
    }
    if ( iPinType==0 )       //  61
    {
        if (iAccountLen!=16)
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "account length range(16)";
            InitEnableButton();
            return;
        }
        sprintf(cpComm,"%s%c%s%s",
                         szKeyNo,
                         szPinType,
                         szAccount,
                         szAccount1 );
    }
    int iTimeOut = GetPrivateProfileInt( "PINRENEW","TIMEOUT",30,".\\KeyStock.txt" );

    iRet = g_fPinpadGetPinValue(cpComm,strlen(cpComm),iTimeOut,szPinValue);
    InitEnableButton();
    if (iRet)
    {
        GetErrStatus(iRet,chErrMsg);
        sprintf(szErr, "failure in reading the PIN ,the failure reason is:%s", chErrMsg);
        fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        return;
    }

    memset(szTemp, 0, sizeof(szTemp));
    memcpy(szTemp,szPinValue, 2);
    edPinSerialNo->Text = szTemp;

    memset(szTemp, 0, sizeof(szTemp));
    memcpy(szTemp,szPinValue+2, 2);
    edPinRevLength->Text = szTemp;

    memset(szTemp, 0, sizeof(szTemp));
    strcpy(szTemp,szPinValue+4);
    Edit3->Text = szTemp;

    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in PIN Renew/verify";
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::Button3Click(TObject *Sender)
{
    char szKeyValue[128] = {0},chKeyLabel[10]={0}, szDownloadKey[256] = {0};
    char szPin1[128] = {0},szPin2[128] = {0},szPin3[128] = {0},szKeyNo[3]  = {0};
    char szRevData[128] = {0},chErrMsg[100]={0},szErr[128]={0};

    int iRet = 0, iGetKey = 0;
    //ϳɴ
    int iMixNo;// =  comboMixCode->ItemIndex;
    sscanf( comboMixCode->Text.c_str(),"%02X",&iMixNo );
    //Կȴ
    int iKeyLength = comboPinLength->ItemIndex;

    iStop = 0;
    edDownLoadKeyRetValue->Text = "";
    g_BegainReadPin = 0;
    InitDisableButton();
    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "";
    //key  
    memcpy(szKeyNo, comboKeyNo->Text.c_str(),2);
    if (strlen(szKeyNo) <= 0)
    {
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "vacant key no. is forbidden(value range : 00 - 1F)";
        comboKeyNo->SetFocus();
        InitEnableButton();
        return;
    }
    else
    {
        if ( (szKeyNo[0]<'0') || (szKeyNo[0]>'1') || (szKeyNo[1]<'0') || ( (szKeyNo[1]>'9') && (szKeyNo[1]<'A') ) || (szKeyNo[1]>'F') )
        {
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "invalid key no.(value range:00-1F)";
            comboKeyNo->SetFocus();
            InitEnableButton();
            return;
        }
    }

    strcpy(szPin1, edPin1->Text.c_str());
    if ((strlen(szPin1) <= 0)||(memcmp(szPin1,"********",8)==0)||(iMixNo>=0x40))
    {
        if ( iMixNo==0x40 )
        {
///////////////zph 2005/12/08/////////////////////////
            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "at present ,don't support this combination code please other combination code";
            InitEnableButton();
            return;
//////////////////////////////////////////////////////
/*
            if ( comboPinLength->Text.ToInt()==8 )
                sprintf(szDownloadKey, "%s%c2", szKeyNo, iMixNo);
            else if ( comboPinLength->Text.ToInt()==16 )
                sprintf(szDownloadKey, "%s%c4", szKeyNo, iMixNo);
            else
                sprintf(szDownloadKey, "%s%c6", szKeyNo, iMixNo);
*/
        }
        else
        {
///////////////zph 2005/12/08/////////////////////////
            if ( iMixNo==0x30 )
            {
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "at present ,don't support this combination code please other combination code";
                InitEnableButton();
                return;
            }
//////////////////////////////////////////////////////
            if ( iMixNo==0x33 )
                sprintf(szDownloadKey, "%s%c%d", szKeyNo, iMixNo, iKeyLength+1+2);
            else
                sprintf(szDownloadKey, "%s%c%d", szKeyNo, iMixNo, iKeyLength+1);
        }
        strcpy(szKeyValue, "****************");
        strcpy(szPin1, "****************" );
        strcpy(szPin2, "****************" );
        strcpy(szPin3, "****************" );
    }
    else
    {
        switch(iMixNo-0x30)
        {
            case 0:
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "at present ,don't support this combination code please other combination code";
                InitEnableButton();
                return;
/*
                sprintf(szDownloadKey, "%s%c%d%s", szKeyNo, iMixNo, iKeyLength+1, szPin1);
                strcpy(szKeyValue, szPin1);
                break;
*/
            case 1:
                strcpy(szPin2, edPin2->Text.c_str());
                if (strlen(szPin2) <= 0)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second  part clear text key can't be vacant";
                    edPin2->SetFocus();
                    InitEnableButton();
                    return;
                }
                strcpy(szPin3, edPin3->Text.c_str());
                if (strlen(szPin3) <= 0)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the third  part clear text key can't be vacant";
                    edPin3->SetFocus();
                    InitEnableButton();
                    return;
                }

                sprintf(szDownloadKey, "%s%c%d%s%s%s", szKeyNo, iMixNo, iKeyLength+1, szPin1, szPin2, szPin3);
                iGetKey =   MixThreeKey(szPin1, szPin2, szPin3, iKeyLength+1, szKeyValue);

                if ( iGetKey == -1)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the first part clear test key length is not long enough";
                    edPin1->SetFocus();
                    InitEnableButton();
                    return;
                }
                if ( iGetKey == -2)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second  part clear test key length is not long enough";
                    edPin2->SetFocus();
                    InitEnableButton();
                    return;
                }
                if ( iGetKey == -3)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the third  part clear test key length is not long enough";
                    edPin2->SetFocus();
                    InitEnableButton();
                    return;
                }
                break;
            case 2:
                strcpy(szPin2, edPin2->Text.c_str());
                if (strlen(szPin2) <= 0)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second  part clear text key can't be vacant";
                    InitEnableButton();
                    return;
                }
                sprintf(szDownloadKey, "%s%c%d%s%s", szKeyNo, iMixNo, iKeyLength+1, szPin1, szPin2);

                iGetKey =  MixTwoKey(szPin1, szPin2,  iKeyLength+1, szKeyValue);
                if ( iGetKey == -1)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the first part clear test key length is not long enough";
                    edPin1->SetFocus();
                    InitEnableButton();
                    return;
                }
                if ( iGetKey == -2)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second  part clear test key length is not long enough";
                    edPin2->SetFocus();
                    InitEnableButton();
                    return;
                }
                break;
            case 3:
                if (strlen(szPin1) != 16)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the first part clear test key length is 8 bytes(16 character)";
                    InitEnableButton();
                    return;
                }
                strcpy(szPin2, edPin2->Text.c_str());
                if (strlen(szPin2) != 16)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second part clear test key length is 8 bytes16 character";
                    InitEnableButton();
                    return;
                }
                strcpy(szPin3, edPin3->Text.c_str());
                if (strlen(szPin3) != 16)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the third part clear test key length is 8 bytes16 character";
                    InitEnableButton();
                    return;
                }
                sprintf(szDownloadKey, "%s%c%d%s%s%s", szKeyNo, iMixNo, iKeyLength+1+2, szPin1, szPin2, szPin3);
                sprintf( szKeyValue,"%s%s%s", szPin1, szPin2, szPin3 );
                break;
            case 4:
                strcpy(szPin2, edPin2->Text.c_str());
                if (strlen(szPin2) <= 0)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second  part clear test key length is not long enough";
                    edPin2->SetFocus();
                    InitEnableButton();
                    return;
                }
                sprintf(szDownloadKey, "%s%c%d%s%s", szKeyNo, iMixNo, iKeyLength+1, szPin1, szPin2 );
                iGetKey = DataXorTwoKey(szPin1, szPin2, iKeyLength+1, szKeyValue);

                if ( iGetKey == -1)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the first part clear test key length error";
                    edPin1->SetFocus();
                    InitEnableButton();
                    return;
                }
                if ( iGetKey == -2)
                {
                    fmTestZt588->StatusBar1->Panels->Items[1]->Text = "in the second part clear test key length error";
                    edPin2->SetFocus();
                    InitEnableButton();
                    return;
                }
                break;
            default:
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "at present ,don't support this combination code please other combination code";
                InitEnableButton();
                return;
        }
    }

    if (g_fPinpadDownloadKey)
    {
        InitEnableButton();
        iRet = g_fPinpadDownloadKey(szDownloadKey,
                                    strlen(szDownloadKey),
                                    szRevData);
        edPin1->Text = szPin1;
        edPin2->Text = szPin2;
        edPin3->Text = szPin3;

        if (!iRet)
        {
            if ( iMixNo>=0x40 )
            {
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "Please input the clear text key from EPP";
                MSG Message;
                int i=0;
                char cpDisp[256]={0},cpBuf[3]={0};
                btCloseCom->Enabled = FALSE;
                while(1)
                {
                    if( ::PeekMessage(&Message,NULL,0,0,PM_REMOVE) )
                    {
	                ::TranslateMessage(&Message);
	                ::DispatchMessage(&Message);
                    }
                    if ( iStop == 1 )
                        break;
                    memset( cpBuf,'\0',sizeof(cpBuf) );
                    iRet = g_fPinpadReadOneByte( cpBuf );
                    if ( iRet>0 )
                    {
                        if (( (int)cpBuf[0]==0x1B )||( (int)cpBuf[0]==(int)0x80))
                        {
                            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "Canceled input or timeout in the clear text key";
                            InitEnableButton();
                            btCloseCom->Enabled = TRUE;
                            break;
                        }
                        if ( cpBuf[0]==0x08 )
                        {
                            if ( i>=1 )
                            {
                                i--;
                                cpDisp[i]='\0';
                            }
                            if ((iMixNo==0x40 )||(iMixNo==0x41 ))
                                edPin1->Text = cpDisp;
                            else if ( iMixNo==0x42 )
                                edPin2->Text = cpDisp;
                            else
                                edPin3->Text = cpDisp;
                            continue;
                        }
                        if ( cpBuf[0]==0x0d )
                        {
                            btCloseCom->Enabled = TRUE;
                            fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in the clear text key";
                            if ((iMixNo==0x40 )||(iMixNo==0x41 ))
                            {
                                sprintf( chKeyLabel,"%s_1",szKeyNo );
                                SaveKey("KEY_MINWEN", chKeyLabel, cpDisp);
                            }
                            else if ( iMixNo==0x42 )
                            {
                                sprintf( chKeyLabel,"%s_2",szKeyNo );
                                SaveKey("KEY_MINWEN", chKeyLabel, cpDisp);
                            }
                            else
                            {
                                sprintf( chKeyLabel,"%s_3",szKeyNo );
                                SaveKey("KEY_MINWEN", chKeyLabel, cpDisp);
                            }
                            char cpKeyVal[128]={0};
                            sprintf( cpKeyVal,"%s_V",szKeyNo );
                            SaveKey("KEY_MINWEN",cpKeyVal,"****************");
                            InitEnableButton();
                            break;
                        }
                        cpDisp[i]=cpBuf[0];
                        i++;
                        if ((iMixNo==0x40 )||(iMixNo==0x41 ))
                            edPin1->Text = cpDisp;
                        else if ( iMixNo==0x42 )
                            edPin2->Text = cpDisp;
                        else
                            edPin3->Text = cpDisp;
                    } //if(iRet>0)
                } //while()
            } //if ( iMixNo>=0x40 )
            else
            {
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = "succeed in downloading the clear text key";
                edDownLoadKeyRetValue->Text = szRevData;

                sprintf( chKeyLabel,"%s_1",szKeyNo );
                SaveKey("KEY_MINWEN", chKeyLabel, szPin1);
                sprintf( chKeyLabel,"%s_2",szKeyNo );
                SaveKey("KEY_MINWEN", chKeyLabel, szPin2);
                sprintf( chKeyLabel,"%s_3",szKeyNo );
                SaveKey("KEY_MINWEN", chKeyLabel, szPin3);
                char cpKeyVal[128]={0};
                sprintf( cpKeyVal,"%s_V",szKeyNo );
                SaveKey("KEY_MINWEN",cpKeyVal,szKeyValue);
                InitEnableButton();
            }
        }//if (!iRet)
        else
        {
            GetErrStatus(iRet,chErrMsg);
            edDownLoadKeyRetValue->Text = "";
            sprintf(szErr, "failure in downloading clear text key,the failure reason is:%s", chErrMsg);
            fmTestZt588->StatusBar1->Panels->Items[1]->Text =   szErr;
        }
     }//if (g_fPinpadDownloadKey)
     else
     {
        InitEnableButton();
        fmTestZt588->StatusBar1->Panels->Items[1]->Text = "failure in selecting function PinPad_DownloadKey()";
     }
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::TabSheet8_DisplayClick(TObject *Sender)
{
        int iRet = 0;
        char pszInfo[256] = {0};
        int iLen = 0;
        char chErrMsg[100]={0},szErr[128]={0};

        char temp[256]={0},mode[4]={0};
        int len = TS8_Combox->Text.Length();
        int outlen = 0;
        strncpy(temp,TS8_Combox->Text.c_str(),len);
        char temp2[256] = {0};
        for(int i =0;i<len;i++)
        {
                if ((temp[i]<'0')||(temp[i]>'9'&&temp[i]<'A')||(temp[i]>'F'&&temp[i]<'a')||(temp[i]>'f'))
                     continue;
                temp2[outlen++] = temp[i];
        }
        if ( outlen%2!=0 )
        {
                StatusBar1->Panels->Items[1]->Text="Invalid Prefill value";
                return;
        }
        gCompressAsc(temp2,outlen,mode);
        outlen = outlen/2;

        if(mode[0] == 0x30)
        {
                char temp3[256]={0}, temp4[256]={0};

                char InCharSet[256]={0};
                len = TS8_Memo3->Text.Length();
                outlen = 0;
                strncpy(temp3,TS8_Memo3->Text.c_str(),len);
                for(int i =0;i<len;i++)
                {
                        if ((temp3[i]<'0')||(temp[i]>'9'&&temp3[i]<'A')||(temp3[i]>'F'&&temp3[i]<'a')||(temp3[i]>'f'))
                                continue;
                        temp4[outlen++] = temp3[i];
                }
                if ( outlen%2 != 0)
                {
                        StatusBar1->Panels->Items[1]->Text="Invalid data";
                        return;
                }
                gCompressAsc(temp4,outlen,InCharSet);

                outlen = outlen/2;
                pszInfo[0] = mode[0];
                memcpy(pszInfo+1,InCharSet,outlen);
                iLen = outlen + 1;
        }

        if(mode[0] == 0x31)
        {
                char temp3[256]={0};
                char linemode[4] = {0};
                len = TS8_ComboBox4->Text.Length();
                outlen = 0;
                strncpy(temp3,TS8_ComboBox4->Text.c_str(),len);
                char temp4[256] = {0};
                for(int i =0;i<len;i++)
                {
                        if ((temp3[i]<'0')||(temp3[i]>'9'&&temp3[i]<'A')||(temp3[i]>'F'&&temp3[i]<'a')||(temp3[i]>'f'))
                                continue;
                        temp4[outlen++] = temp3[i];
                }
                if ( outlen%2!=0 )
                {
                        StatusBar1->Panels->Items[1]->Text="Invalid Prefill value";
                        return;
                }
                gCompressAsc(temp4,outlen,linemode);
                outlen = outlen/2;

                pszInfo[0] = mode[0];
                memcpy(pszInfo+1,linemode,outlen);
                iLen = 1 + 1;
        }

        if(mode[0] == 0x32)
        {
                char temp3[256]={0};
                char linemode[4] = {0};
                len = TS8_ComboBox4->Text.Length();
                outlen = 0;
                strncpy(temp3,TS8_ComboBox4->Text.c_str(),len);
                char temp4[256] = {0};
                for(int i =0;i<len;i++)
                {
                        if ((temp3[i]<'0')||(temp3[i]>'9'&&temp3[i]<'A')||(temp3[i]>'F'&&temp3[i]<'a')||(temp3[i]>'f'))
                                continue;
                        temp4[outlen++] = temp3[i];
                }
                if ( outlen%2 != 0 )
                {
                        StatusBar1->Panels->Items[1]->Text="Invalid Prefill value";
                        return;
                }
                gCompressAsc(temp4,outlen,linemode);
                outlen = outlen/2;

                pszInfo[0] = mode[0];
                memcpy(pszInfo+1,linemode,outlen);
                iLen = 1 + 1;
        }

        if(mode[0] >= 0x40 && mode[0] <= 0x7F)
        {
                char temp3[256]={0}, temp4[256]={0};

//                char InCharSet[256]={0};
                TS8_Memo3->MaxLength = 64;
                len = TS8_Memo3->Text.Length();
                if(len > TS8_Memo3->MaxLength)
                {
                        StatusBar1->Panels->Items[1]->Text="ciphertext's length exceed";
                        return;
                }
                outlen = 0;
                strncpy(temp3,TS8_Memo3->Text.c_str(),len);
                for(int i =0;i<len;i++)
                {
                        if ((temp3[i]<'0')||(temp3[i]>'9'&&temp3[i]<'A')||(temp3[i]>'F'&&temp3[i]<'a')||(temp3[i]>'f'))
                                continue;
                        temp4[outlen++] = temp3[i];
                }
                if ( outlen%16 != 0)
                {
                        StatusBar1->Panels->Items[1]->Text="Invalid data";
                        return;
                }
                pszInfo[0] = mode[0];
                memcpy(pszInfo+1,temp4,outlen);
                iLen = outlen + 1;
        }

        iRet = g_fPinPadDispInfoLcd(pszInfo,iLen);
        
        if( !iRet )
        {
                StatusBar1->Panels->Items[1]->Text="success";
        }
        else
        {
                GetErrStatus(iRet,chErrMsg);
                TS8_Memo3->Text = "";
                sprintf(szErr, "failure in displaying ,the failure reason is:%s", chErrMsg);
                fmTestZt588->StatusBar1->Panels->Items[1]->Text = szErr;
        }
}
//---------------------------------------------------------------------------

void __fastcall TfmTestZt588::TS8_ComboxChange(TObject *Sender)
{
       int iValue;// = comboControlCode->Text.ToInt();
        int i;
        char chNo[2]={0};

        char* cp = new char[ TS8_Combox->Text.Length() + 1 ];
        strcpy( cp, TS8_Combox->Text.c_str() );

        gCompressAsc(cp,2,chNo);
        iValue = chNo[0];


        if(iValue >=64 && iValue <= 127)
        {
                TS8_Label10->Caption = "Decryption display";
                TS8_Label11->Caption = "cipher(HEX)";
                TS8_Label11->Visible = TRUE;
                TS8_Label12->Visible = FALSE;
                TS8_Memo3->Text = "";
                TS8_ComboBox4->Visible = FALSE;
                TS8_Memo3->Visible = TRUE;
        }
        switch(iValue)
        {
        case 48:
                TS8_Label10->Caption = "Original code display";
                TS8_Label11->Caption = "Context(HEX)";
                TS8_Label11->Visible = TRUE;
                TS8_Label12->Visible = FALSE;
                TS8_Memo3->Text = "";
                TS8_ComboBox4->Visible = FALSE;
                TS8_Memo3->Visible = TRUE;
                break;
        case 49:
                TS8_Label10->Caption = "Code display";
                TS8_Label11->Visible = FALSE;
                TS8_Label12->Visible = TRUE;
                TS8_Memo3->Visible = FALSE;
                TS8_ComboBox4->Visible = TRUE;
                TS8_ComboBox4->Text = "30";
                break;
        case 50:
                TS8_Label10->Caption = "Code display";
                TS8_Label11->Visible = FALSE;
                TS8_Label12->Visible = TRUE;
                TS8_Memo3->Visible = FALSE;
                TS8_ComboBox4->Visible = TRUE;
                TS8_ComboBox4->Text = "30";
                break;
        default:
                StatusBar1->Panels->Items[1]->Text="Invalid Code";
                break;
        }
}
//---------------------------------------------------------------------------



